/* 
 * $Id: C-ident.h,v 1.1.1.1 2004-02-06 18:13:05 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* storage classes */

#ifndef __IDENT_H__
#define __IDENT_H__

typedef enum storage_class {
    SNULL = 0,	/* undefined */
    AUTO,	/* auto variable,1 */
    PARAM,	/* paramter,2 */
    EXTERN,	/* extern variable,3 */
    EXTDEF,	/* external defition,4 */
    STATIC,	/* static variable,5 */
    REGISTER,	/* register variable,6 */
    LABEL,	/* label,7 */
    ULABEL,	/* undefined label, (temporary),8 */
    TAGNAME,	/* tag name for struct/union/enum,9 */
    MOE,	/* member of enum,10 */
    TYPEDEF_NAME,	/* typedef name,11 */
    STORAGE_CLASS_END
} STORAGE_CLASS;

#define N_STORAGE_CLASS ((int)STORAGE_CLASS_END)

extern char *storage_class_names[];

#define STORAGE_CLASS_NAMES \
{ \
  "*",\
  "auto",\
  "param",\
  "extern",\
  "extern_def",\
  "static",\
  "register",\
  "label",\
  "_label",\
  "tagname",\
  "moe",\
  "typedef_name",\
}

typedef struct ident_descriptor {
    struct ident_descriptor *ip_next;	/* next ID */
    SYMBOL name;			/* key(symbol) */
    STORAGE_CLASS class;		/* storage class */
    char label_is_defined;
    char bit_field_len;
    char error_flag;			/* error has occured */
    char hide_flag;			/* hide some variable */
    struct type_descriptor *type;	/* type */
    expv base;			/* base address expression value */
} *ID;

#define ID_NEXT(ip)		((ip)->ip_next)
#define ID_SYM(ip)		((ip)->name)
#define ID_NAME(ip)		SYM_NAME((ip)->name)
#define ID_TYPE(ip)		((ip)->type)
#define ID_CLASS(ip)		((ip)->class)
#define ID_BASE(ip)		((ip)->base)
#define ID_CASE_EXPV(ip)	((ip)->base)	/* case statement */
#define ID_LABEL_IS_DEFINED(ip)		((ip)->label_is_defined)
#define ID_BIT_FIELD_LEN(ip)	((ip)->bit_field_len)
#define ID_ERROR(ip)		((ip)->error_flag)
#define ID_HIDE(ip) 		((ip)->hide_flag)

#endif
