static char rcsid[] = "$Id: machine-dep.c,v 1.1.1.1 2004-02-06 18:13:09 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* machine dependent byte size and align information */

#include "C-front.h"

#ifndef SIZEOF_UNSIGNED_LONG_LONG
#define SIZEOF_UNSIGNED_LONG_LONG (SIZEOF_UNSIGNED_INT * 2)
#endif /* !SIZEOF_UNSIGNED_LONG_LONG */

#ifndef LONGLONG_ALIGN
#define LONGLONG_ALIGN (LONG_ALIGN * 2)
#endif /* !LONGLONG_ALIGN */

/* routine for machine depedent part */
int     enum_type_size = SIZEOF_UNSIGNED_LONG/*?*/;
int     enum_type_align = SIZEOF_UNSIGNED_LONG/*?*/;
int     pointer_type_size = SIZEOF_VOID_P;
int     pointer_type_align = SIZEOF_VOID_P;
int	alignment_double = FALSE;

/* byte size information for only basic type(NOT included 'enum') */
int basic_type_size(BASIC_DATA_TYPE type)
{
    switch (type) {
    case UNDEF:
    case VOID:
	return (0);
    case CHAR:
    case UNSIGNED_CHAR:
	return (1);
    case SHORT:
    case UNSIGNED_SHORT:
	return SIZEOF_UNSIGNED_SHORT;
    case INT:
    case UNSIGNED:
    case SIGNED:
	return SIZEOF_UNSIGNED_INT;
    case LONG:
    case UNSIGNED_LONG:
	return SIZEOF_UNSIGNED_LONG;
    case LONGLONG:
    case UNSIGNED_LONGLONG:
	return SIZEOF_UNSIGNED_LONG_LONG;
    case FLOAT:
	return SIZEOF_FLOAT;
    case DOUBLE:
	return SIZEOF_DOUBLE;
    case LONG_DOUBLE:
#if defined(SIZEOF_LONG_DOUBLE)
	return SIZEOF_LONG_DOUBLE;
#else
	return sizeof(long double);
#endif /* SIZEOF_LONG_DOUBLE */
    default:
	fatal("basic_type_size");
	return 0;
    }
}

int basic_type_align(BASIC_DATA_TYPE type)
{
    switch (type) {
    case UNDEF:
    case VOID:
    case CHAR:
    case UNSIGNED_CHAR:
	/* nothing */
	return CHAR_ALIGN;
    case SHORT:
    case UNSIGNED_SHORT:
	return SHORT_ALIGN;
    case INT:
    case SIGNED:
    case UNSIGNED:
	return INT_ALIGN;
    case LONG:
    case UNSIGNED_LONG:
	return LONG_ALIGN;
    case LONGLONG:
    case UNSIGNED_LONGLONG:
#ifdef OMNI_CPU_I386
	if (alignment_double) {
# ifdef I386_LONGLONG_ALIGN2
	    return I386_LONGLONG_ALIGN2;
# else
	    return LONGLONG_ALIGN;
# endif /* I386_LONGLONG_ALIGN2 */
	} else {
	    return LONGLONG_ALIGN;
	}
#else
	return LONGLONG_ALIGN;
#endif /* OMNI_CPU_I386 */
    case FLOAT:
	return FLOAT_ALIGN;
    case DOUBLE:
#ifdef OMNI_CPU_I386
	if (alignment_double) {
# ifdef I386_DOUBLE_ALIGN2
	    return I386_DOUBLE_ALIGN2;
# else
	    return LONGLONG_ALIGN;
# endif /* I386_DOUBLE_ALIGN2 */
	} else {
	    return DOUBLE_ALIGN;
	}
#else
	return DOUBLE_ALIGN;
#endif /* OMNI_CPU_I386 */
    case LONG_DOUBLE:
#if defined(LONGDOUBLE_ALIGN)
	return LONGDOUBLE_ALIGN;
#else
	return DOUBLE_ALIGN *2;
#endif /* LONGDOUBLE_ALIGN */
    default:
	fatal("basic_type_align");
	return 0;
    }
}

