/*
 * This file was written by Chiba
 */

#include "F-front.h"

static int is_scm_pragma(char* keyword);

void compile_SCM_directive(expr x)
{
    char* dir;

    if(x == NULL)
	return;		/* error */

    if(debug_flag){
	printf("OMP_directive:\n");
	expv_output(x, stdout);
	putchar('\n');
    }

    dir = SYM_NAME(EXPR_SYM(EXPR_ARG1(x)));
    printf("dir: %s\n", dir);

    if (strcmp(dir, "begin") == 0 || strcmp(dir, "pbegin") == 0
	|| strcmp(dir, "escape") == 0) {
	push_ctl(CTL_SCM);
	CTL_CLIENT(ctl_top) = x;
	EXPR_LINE(CTL_CLIENT(ctl_top)) = current_line;
    }
    else if (strcmp(dir, "end") == 0) {
	if(CTL_TYPE(ctl_top) == CTL_SCM) {
	    expr e = CTL_CLIENT(ctl_top);
	    CTL_BLOCK(ctl_top) = list4(SCM_PRAGMA,
				       EXPR_ARG1(e), EXPR_ARG2(e),
				       EXPR_ARG3(e), current_statements);
	    EXPR_LINE(CTL_BLOCK(ctl_top)) = EXPR_LINE(CTL_CLIENT(ctl_top));
	    pop_ctl();
	}
	else
	    error("SCM block is not closed");
    }
    else if (strcmp(dir, "opt_reusable") == 0 || 
	     strcmp(dir, "opt_notreusable") == 0 ) {
	push_ctl(CTL_SCM);
	CTL_CLIENT(ctl_top) = x;
	EXPR_LINE(CTL_CLIENT(ctl_top)) = current_line;
    }
    else if (strcmp(dir, "element") == 0 ) {
	push_ctl(CTL_SCM);
	CTL_CLIENT(ctl_top) = x;
	EXPR_LINE(CTL_CLIENT(ctl_top)) = current_line;
    }
    else if (is_scm_pragma(dir))
	output_statement(x);
    else
	fatal("unknown SCM pragma");
}

static char* scm_keywords[] = {
    "uncache", "load", "pload", "store", "pstore", "swap", "copyto",
    "way_set", "element", "option"
};

static int is_scm_pragma(char* keyword)
{
    int i;
    for (i = 0; i < sizeof(scm_keywords) / sizeof(scm_keywords[0]); ++i)
	if (strcmp(keyword, scm_keywords[i]) == 0)
	    return 1;

    return 0;
}
