// $Id: BlockIterator.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.block;

import exc.object.*;

/**
 * super class for Block iterator 
 */
public abstract class BlockIterator {
  Block currentBlock;

  /** constructor with block */
  public BlockIterator(Block b){
    currentBlock = b;	// set defaults
  }
  
  public BlockIterator(BlockList body){
    // nothing
  }

  public abstract void init();
  public abstract void init(Block b);
  public abstract void next();
  public abstract boolean end();
  public abstract int size();
    
  /** Return the current block */
  public Block getBlock(){  return currentBlock; }

  /*+ replace the current block with Block b */
  public void setBlock(Block b){ currentBlock.replace(b); }
}

