// $Id: CompoundBlock.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $OMNI_Release$
// $OMNI_Copyright$
package exc.block;
import exc.object.*;

/**
 * Compound block with code COMPOUND_STATEMENT.
 */ 
public class CompoundBlock extends Block {
  BlockList body;

  /** constructor with BlockList */
  public CompoundBlock(BlockList body){
    super(Xcode.COMPOUND_STATEMENT,null);
    this.body = body;
    if(body != null) body.parent = this;
  }

  /** constructor with code and BlockList */
  public CompoundBlock(int code, BlockList body){
    super(code,null);
    this.body = body;
    if(body != null) body.parent = this;
  }

  /** make clone */
  public CompoundBlock(CompoundBlock b){
    super(b);
    if(b.body != null) this.body = b.body.copy();
  }

  /** make clone */
  public Block copy() { return new CompoundBlock(this); }

  /** return body */
  public BlockList getBody() { return body; }
  /** set body */
  public void setBody(BlockList s){
    body = s;
    s.parent = this;
  }

  /** convert to Xobject representation */
  public Xobject toXobject(){
    if(body == null) return null;
    Xobject x = body.toXobject();
    if(x != null) x.setLineNo(getLineNo());
    return x;
  }
}



