// $Id: CondBlock.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.block;
import exc.object.*;

//
// Block, which has one condition and body
//   WHIILE_STATEMENT, DO_STATEMENT, SWITCH_STATEMENT
//
public class CondBlock extends Block {
  BlockList body;

  public CondBlock(int code,BasicBlock cond, BlockList body){
    super(code,cond);
    this.body = body;
    body.parent = this;
  }

  public CondBlock(CondBlock b){
    super(b);
    body = b.body.copy();
    body.parent = this;
  }
  
  public Block copy() { return new CondBlock(this); }
  
  public BlockList getBody() { return body; }
  public void setBody(BlockList s){
    body = s;
    s.parent = this;
  }

  public BasicBlock getCondBBlock() { return bblock; }
  public void setCondBBlock(BasicBlock bb) { 
    bblock = bb; 
    bb.parent = this;
  }

  public Xobject toXobject(){
    Xobject x;
    Xobject cond_x = null;
    if(bblock != null) cond_x = bblock.toXobject();
    if(code == Xcode.DO_STATEMENT)
      x = new XobjList(code,body.toXobject(),cond_x);
    else
      x = new XobjList(code,cond_x,body.toXobject());
    x.setLineNo(getLineNo());
    return x;
  }
}


