// $Id: FunctionBlock.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $OMNI_Release$
// $OMNI_Copyright$

package exc.block;

import exc.object.*;

/**
 * A block object to represent the function body.
 */

public class FunctionBlock extends CompoundBlock {
  String func_name;
  XobjectFile env;
  
  /** 
   * contructor with function name "name", id list, decls, body block
   * and env. id_list and decls are for parameters.
   */
  public FunctionBlock(String name,Xobject id_list,
	Xobject decls,Block body_block, XobjectFile env){
    super(Xcode.FUNCTION_DEFINITION,new BlockList(id_list,decls));
    this.env = env;
    this.func_name = name;
    body.add(body_block);
  }

  /** returns Function name */
  public String getName() { return func_name; }
  /** return associated XobjectFile env */
  public XobjectFile getFile() { return env; }

  /** contert to Xobject */
  public Xobject toXobject(){
    Xobject x =  new XobjList(Opcode(),Xcons.Symbol(Xcode.IDENT,func_name),
			      body.id_list,body.decls,body.head.toXobject());
    x.setLineNo(getLineNo());
    return x;
  }
}



