// $Id: bottomupBlockIterator.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.block;
import exc.object.*;
import java.util.Vector;

public class bottomupBlockIterator extends BlockIterator {
  Vector blocks;
  int index;

  public bottomupBlockIterator(Block b){
    super(b);
    init(b);
  }

  public bottomupBlockIterator(BlockList body){
    super(body);
    init(body);
  }

  public void init() { index = 0; currentBlock = (Block)blocks.elementAt(0);}

  public void init(Block b){
    blocks = new Vector();
    bottomupTraverse(b);
    index = 0; 
    currentBlock = (Block)blocks.elementAt(0);
  }

  public void init(BlockList body){
    blocks = new Vector();
    bottomupTraverse(body);
    index = 0; 
    currentBlock = (Block)blocks.elementAt(0);
  }

  void bottomupTraverse(Block b){
    if(b == null) return;
    if(b instanceof IfBlock){
      bottomupTraverse(b.getThenBody());
      bottomupTraverse(b.getElseBody());
    } else {
      bottomupTraverse(b.getBody());
    }
    blocks.addElement((Object)b);
  }

  void bottomupTraverse(BlockList b_list){
    if(b_list == null) return;
    for(Block b = b_list.getHead(); b != null; b = b.getNext()){
      bottomupTraverse(b);
    }
  }

  public void next(){ 
    if(++index >= blocks.size()) currentBlock = null;
    else currentBlock = (Block)blocks.elementAt(index);
  }
  
  public boolean end(){ return index >= blocks.size(); }
  public int size() { return blocks.size(); }
}


