// $Id: topdownBlockIterator.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.block;
import exc.object.*;
import java.util.Vector;

public class topdownBlockIterator extends BlockIterator {
  Vector blocks;
  int index;

  public topdownBlockIterator(Block b){
    super(b);
    init(b);
  }

  public topdownBlockIterator(BlockList body){
    super(body);
    init(body);
  }

  public void init() { index = 0; currentBlock = (Block)blocks.elementAt(0);}

  public void init(Block b){
    blocks = new Vector();
    topdownTraverse(b);
    index = 0; 
    currentBlock = (Block)blocks.elementAt(0);
  }

  public void init(BlockList body){
    blocks = new Vector();
    topdownTraverse(body);
    index = 0; 
    currentBlock = (Block)blocks.elementAt(0);
  }

  void topdownTraverse(Block b){
    if(b == null) return;
    blocks.addElement((Object)b);
    if(b instanceof IfBlock){
      topdownTraverse(b.getThenBody());
      topdownTraverse(b.getElseBody());
    } else {
      topdownTraverse(b.getBody());
    }
  }

  void topdownTraverse(BlockList b_list){
    if(b_list == null) return;
    for(Block b = b_list.getHead(); b != null; b = b.getNext()){
      topdownTraverse(b);
    }
  }

  public void next(){ 
    if(++index >= blocks.size()) currentBlock = null;
    else currentBlock = (Block)blocks.elementAt(index); 
  }

  public boolean end(){ return index >= blocks.size(); }
  public int size() { return blocks.size(); }
}


