// $Id: forallInfo.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.flow;

import exc.object.*;
import exc.block.*;
import exc.openmp.*;
import exc.util.XobjectSet;

public class forallInfo extends loopInfo {
  OMPforallBlock forall_b;
  public forallInfo(optBodyEnv env, OMPforallBlock b){
    super(env,
	  b.beginBasicBlock().getCflowOut(0),
	  b.endBasicBlock().getCflowIn(0),
	  b.beginBasicBlock(),
	  b.endBasicBlock());
    forall_b = b;
  }
  
  public void analyzeLoop(XobjectSet readOnlySet){
    this.readOnlySet = readOnlySet;

    chkOp = forall_b.getCheckOpcode();
    incOp = Xcode.PLUS_EXPR;
    step = forall_b.getStep();
    ub = forall_b.getUpperBound();
    lb = forall_b.getLowerBound();

    // don't need find loop variable!
    loop_var = forall_b.getLoopVar();

    collectLoopInvariant();
  }

  public rangeExpr rangeExpr(Xobject e){
    return rangeExpr.ForAll(lb,ub,step,incOp,chkOp,
			    Xcons.List(stepExpr(e,Xcons.IntConstant(1)),
				       inductionExpr(e,Xcons.IntConstant(0))),
			    forall_b.getSched(),
			    forall_b.getChunk());
  }

  public rangeExpr rangeExprWithExpr(Xobject e){
    return rangeExpr.ForAll(lb,ub,step,incOp,chkOp,e,
			    forall_b.getSched(),
			    forall_b.getChunk());
  }
}



