import exc.object.*;

/**
 * Instruction for binary operand operation.
 */
public class BinaryInst extends Inst {
  int op;
  Operand left,right;

  /** constructor */
  public BinaryInst(int kind, int op, int val, Operand left, Operand right){
    super(kind,val);
    this.op = op;
    this.left = left;
    this.right = right;
  }

  /** get opcode */
  public int getOpcode() { return op; }
  /** set opcode */
  public void setOpcode(int op) { this.op = op; }

  /** get left operand */
  public Operand getLeft() { return left; }
  /** set left operand */
  public void setLeft(Operand o) { left = o; }

  /** get right operand */
  public Operand getRight() { return right; }
  /** set right operand */
  public void setRight(Operand o) { right = o; }

  /** convert to Inst to String */
  public String toString(){
    return "["+getKindName()+","+Xcode.getName(op)+
      ","+val+",L:"+left+",R:"+right+"]";
  }
}


