
import java.io.*;
import java.util.*;
import exc.object.*;
import exc.block.*;

/**
 * An object to hold data structures for code generation of a function.
 */
public class FuncInsts implements EmitInstEnv {
  Vector insts;	// instructions
  int N_auto; 	// 
  int nLvars;	// number of local 

  int label_counter;
  int reg_counter;

  Machine mach;
  XobjectFile env;
  
  public FuncInsts(XobjectFile env, Machine mach){
    this.mach = mach;
    this.env = env;

    label_counter = 0;
    reg_counter = 0;
    insts = new Vector();
  }

  /** label generator */
  public int genLabel() { return label_counter++; }

  /** generate regster */
  public int genRegN() { return reg_counter++; }

  /** emit LIR inst */
  public void emit(Inst i) {
    insts.add(i);
    System.out.println(i.toString());
  }

  /* for debug */
  public void dump(){
    for(int i = 0; i < insts.size(); i++)
      System.out.println("["+i+"]:"+insts.elementAt(i));
  }
}


