// package exc.inst;

import java.io.*;
import exc.object.*;
import exc.block.*;

/**
 * the top level of backend code generator phase.
 */

public class backendCGen implements XobjectDefVisitor {

  // environment object
  FuncInsts emit_env;	// environment to emit function code.

  // algorithms
  EmitInst emit_inst;

  public void init(XobjectFile env, Machine mach, String asmFile){
    emit_env = new FuncInsts(env,mach);
    emit_inst = new EmitInst();
  }

  public void doDef(XobjectDef d){
    if(!d.isFuncDef()){
      // ingore now
      return;
    }

    FuncDefBlock fd = new FuncDefBlock(d);
    fd.removeDeclInit();

    new BlockPrintWriter(System.out).print(fd.getBlock());

    emit_inst.run(fd,emit_env);

    emit_env.dump();

    // fd.print();
  }
}


