// $Id: FunctionType.java,v 1.2 2004-02-27 17:20:01 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class FunctionType extends Xtype {
  Xtype ref;		// return type
  Xobject param_list;
  boolean is_function_proto;

  public FunctionType(int id,Xtype ref,Xobject param_list,int size,
		      byte align,boolean ic,boolean iv,boolean is_func_proto){
      super(Xtype.FUNCTION,id,size,align,ic,iv);
      this.ref = ref;
      this.param_list = param_list;
      this.is_function_proto = is_func_proto;
  }
  
  public FunctionType(Xtype ref){
      super(Xtype.FUNCTION,0,0,(byte)0,false,false);
      this.ref = ref;
  }

  public Xtype getRef() { return ref; }
  public Xobject getFuncParam() { return param_list; }
  public boolean isFuncProto() { return is_function_proto; }

  public void setFuncParam(Xobject param_list){
    this.param_list = param_list;
    this.is_function_proto = true;
  }

  public void setFuncParamIdList(Xobject id_list){
    Xobject param_list = Xcons.emptyList();
    for(XobjArgs a = id_list.getArgs(); a != null; a = a.nextArgs()){
      Ident id = (Ident)a.getArg();
      param_list.add(Xcons.Symbol(Xcode.IDENT,id.Type(),id.getName()));
    }
    setFuncParam(param_list);
  }

  public Xtype copy() { 
    return new FunctionType(0,ref,param_list,size,align,
			    is_const,is_volatile,is_function_proto);
  }

  public String toString(){
      return "F"+ Integer.toHexString(type_id);
  }
}

