// $Id: XobjectDefEnv.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

import java.io.*;
import java.util.*;

public class XobjectDefEnv extends PropObject {
  protected Xobject identList;
  protected XobjectDef head,tail;
  protected XobjectDefEnv parent;
  
  public XobjectDefEnv() { }

  public XobjectDefEnv(Xobject identList){
    this.identList = identList;
  }

  public XobjectDef getHead() { return head; }
  public XobjectDef getTail() { return tail; }
  
  public void add(XobjectDef s){
    s.parent = this;
    if(tail == null){
      head = tail = s;
      return;
    }
    tail.next = s;
    s.prev = tail;
    tail = s;
  }

  public void add(Xobject x){
    if(x.Opcode() == Xcode.LIST){
      for(XobjArgs a = x.getArgs(); a != null; a = a.nextArgs())
	add(a.getArg());
      return;
    }
    add(new XobjectDef(x));
  }

  public void insert(XobjectDef s){
    s.parent = this;
    if(tail == null){
      head = tail = s;
      return;
    }
    head.prev = s;
    s.next = head;
    head = s;
  }

  public void insert(Xobject x){
    insert(new XobjectDef(x));
  }
  
  //
  // iterator
  // 
  public void iterateDef(XobjectDefVisitor op){
    for(XobjectDef i = head; i != null; i = i.getNext()) op.doDef(i);
  }

  public void iterateFuncDef(XobjectDefVisitor op){
    for(XobjectDef i = head; i != null; i = i.getNext())
      if(i.isFuncDef()) op.doDef(i);
  }

  // search ident name in identList
  public Ident findIdent(String name){
    for(XobjArgs a = identList.getArgs(); 
	a != null; a = a.nextArgs()){
      Ident id = (Ident) a.getArg();
      if(name.equals(id.getName())) return(id);
    }
    return null;
  }

  // search ident id in identList
  public Ident findIdent(Ident id){
    for(XobjArgs a = identList.getArgs(); 
	a != null; a = a.nextArgs()){
      if(a.getArg() == (Xobject)id) return id;
    }
    return null;
  }
}




