// $Id: bottomupXobjectIterator.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

import java.util.Stack;

public class bottomupXobjectIterator extends XobjectIterator {
    Stack obj_stack;
    Stack arg_stack;

    public bottomupXobjectIterator(Xobject x){
	topXobject = x;
    }

    public void init(){ init(topXobject); }

    public void init(Xobject x){
	obj_stack = new Stack();
	arg_stack = new Stack();

	currentXobject = x;
	while(currentXobject != null &&
	      currentXobject.Opcode() != Xcode.ID_LIST &&
	      currentXobject instanceof XobjList &&
	      currentXobject.getArgs() != null){
	    obj_stack.push(currentXobject);
	    arg_stack.push(currentArgs);
	    currentArgs = null;
	    for(XobjArgs args = currentXobject.getArgs(); args != null;
		args = args.nextArgs()){
		arg_stack.push(currentArgs);
		currentArgs = args;
	    }
	    currentXobject = currentArgs.getArg(); // next
	}
    }

    public void next(){
	if(obj_stack.empty()){
	    currentXobject = null;
	    return;
	}
	currentArgs = (XobjArgs)arg_stack.pop();
	if(currentArgs == null){
	    currentXobject = (Xobject)obj_stack.pop();
	    currentArgs = (XobjArgs)arg_stack.pop();
	    return;
	}
	currentXobject = currentArgs.getArg();
	while(currentXobject != null &&
	      currentXobject.Opcode() != Xcode.ID_LIST &&
	      currentXobject instanceof XobjList &&
	      currentXobject.getArgs() != null){
	    obj_stack.push(currentXobject);
	    arg_stack.push(currentArgs);
	    currentArgs = null;
	    for(XobjArgs args = currentXobject.getArgs(); args != null; 
		args = args.nextArgs()){
		arg_stack.push(currentArgs);
		currentArgs = args;
	    }
	    currentXobject = currentArgs.getArg(); // next
	}
    }

    public boolean end() { 
	return currentXobject == null && obj_stack.empty();
    }

    public Xobject getParent() {
	if(obj_stack.empty()) return null;
	else return (Xobject)obj_stack.peek();
    }
}


