// $Id: ompdcc.java,v 1.2 2004-02-27 17:20:04 msato Exp $
// $RWC_Release$
// $RWC_Copyright$

package ompd;

import exc.object.*;
import exc.openmp.*;
import exc.flow.*;

public class ompdcc extends exc.util.ccDriver {
  public ompdcc(){ super("ompd"); }
  
  public ompdcc(String name){ super(name); }

  public static void main(String args[]){ 
    ompdcc driver = new ompdcc();
    driver.run(args);
  }
  
  public boolean parseArg(String arg){
    if(arg.equals("--no-opt")){
      OMPDtransform.optFlag = false;
      System.out.println("optimize off ...");
      return true;
    } 
    return false;
  }

  public void init(){
    cpp_opts += " -DOMPC -D_OPENMP";
    cpp_opts += " "+getTemplateValue("OMPC_CFLAGS");

    if(getTemplateValue("CFRONT_FLAGS") != null)
      cfront_opts += " "+getTemplateValue("CFRONT_FLAGS");

    ld_opts += " "+getTemplateValue("OMPC_MAIN");
    ld_opts += " "+getTemplateValue("OMPC_LDFLAGS");
  }

  public void run(XobjectFile f){
    if(verbose) System.err.println("transformation pass ... "+
				   f.getSourceFileName());
    f.debugFlag = debugFlag;
    SSAtransform.debugFlag = debugFlag;
    OMPDtransform.debugFlag = debugFlag;

    OMP.setMoveAutoFlag(true);
    
    OMPtranslateBlock op = new OMPtranslateBlock();
    op.init(f,false);
    f.iterateDef(op);   // transform OMP pragma
    if(OMP.errorFlag){
      System.err.println("error in OpenMP. stop.");
      System.exit(1);
    }

    OMPDtransform opOMPD = new OMPDtransform();
    f.iterateFuncDef(opOMPD);

    op.init(f,true);
    f.iterateDef(op);   // transform OMP pragma
  }
}




