/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
package scm;

import scmopt.*;
import exc.object.*;
import exc.block.*;

import java.util.Hashtable;

public class LabelRenamer implements XobjectDefVisitor{
	
	private static int number = 0;
	
	
	
	private Xobject m_xRoot = null;
	private Hashtable m_hash = new Hashtable();
	
	public void doDef(XobjectDef d) {
		m_xRoot = d.getDef();
		
		Xobject xIdList = m_xRoot.getArg(3).getArg(0);
		processIdList(xIdList);
		
		processBody(m_xRoot.getArg(3).getArg(2));
		number ++;
	}
	public void processIdList(Xobject xIdList){
		XobjArgs xArgs = xIdList.getArgs();
		if(xArgs == null) return ;
		
		do{
			Ident x = (Ident)xArgs.getArg();
			if(x == null) return ;
			
			if(x.getStorageClass() == StorageClass.LABEL){
				
				String oldname = x.getName();
				String newname = oldname + "_" + number;
				m_hash.put(oldname, newname);
				
				Ident x2 = new Ident(
				  newname,
				  x.getStorageClass(),
				  x.Type(),
				  x.getValue() );
				
				if(x.isDeclared()) x2.Declared();
				xArgs.setArg(x2);
			}
		}while((xArgs = xArgs.nextArgs()) != null);
	}
	public void processBody(Xobject xBody){
		TopdownIterator iter = new TopdownIterator(xBody);
		for(iter.init() ; !iter.end() ; iter.next()){
			Xobject x = iter.get();
			if(x == null) continue;
			
			if(x.Opcode() == Xcode.IDENT){
				String val = (String)m_hash.get(x.getName());
				if(val != null){
					iter.substitute(new XobjString(
					  x.Opcode(),
					  x.Type(),
					  val));
					iter.skipSubtree();
				}
			}
		}
		
	}
	public String getNewName(String old){
		return old + "_" + number;
	}
}
