/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
package scm;

public interface Names {

    /* void* scm_alloc(int size)
     *     allocates an on-chip cache area.
     */
    static final String ALLOC = "scm_alloc";

    /* void scm_free(void* ptr)
     *     deallocates an on-chip cache area.
     */
    static final String FREE = "scm_free";

    /* void scm_load(void* src, void* dest_onchip, int element_size,
     *               int num_of_elements, int stride_width)
     *     copies from main memory to on-chip memory.
     */
    static final String LOAD = "scm_load";

    /* void scm_store(void* src_onchip, void* dest, int element_size,
     *                int num_of_elements, int stride_width)
     *     copies from on-chip memory to main memory.
     */
    static final String STORE = "scm_store";

    // special subroutines handled as a SCIMA directive

    /* void scm_arraycopy(void* src, int src_index1, src_index2, ...
			  void* dest, int dest_index1, int dest_index2, ...
			  int size1, int size2, ...)
     */
    static final String ARRAY_COPY = "scm_arraycopy";

    /* void scm_wayset(int way_cache, int way_scm)
     */
    static final String WAY_SET = "way_set";

}
