/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
package scm;

import exc.object.*;

/*
 * Data block for handling pbegin pragmas.
 */
public class ScmPBlockOld extends ScmBlockOld {
    public ScmPBlockOld(Xobject name, Xobject params, TranslaterOld trans,
		    ScmBlockOld _next)
    {
	super(name, params, trans, _next);
    }

    /* Called in ScmBlock.makeBlock()
     */
    protected void extraVarDeclaration(StringBuffer code) {
	code.append(makePointerType()).append(' ')
	    .append(getBackPointerName()).append(";\n");
	for (int i = 0; i < dimension; ++i)
	    code.append("int ").append(getBackOffsetName(i))
		.append(" = 0;\n");
	for (int i = 0; i < dimension; ++i)
	    code.append("int ").append(getBackCacheSize(i))
		.append(" = ").append(translater.toString(sizeList[i]))
		.append(";\n");
    }

    /* Produces code for allocating an on-chip memory area.
     */
    protected void makeAlloc(StringBuffer code) {
	makeAlloc(getPointerName(), code);
	makeAlloc(getBackPointerName(), code);
    }

    protected String makeFree() {
	return super.makeFree() + FREE + "(" + getBackPointerName() + ");\n";
    }

    /* Returns the name of the variable holding an offset value
     * for a background on-chip memory area.
     */
    public String getBackOffsetName(int dim) {
	return varName + "_boffset" + dim;
    }

    public String getBackCacheSize(int dim) {
	return varName + "_bsize" + dim;
    }

    /* Returns the name of pointer to a background on-chip memory area.
     */
    public String getBackPointerName() {
	return varName + "_bptr";
    }
}
