/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
package scm;

import java.io.*;
import java.util.*;
import exc.object.*;

/* This class is equal to exc.object.XobjectFile except that an
 * XobjectDecompileWriter object is created by a factory method.
 */

public class XobjectFile extends exc.object.XobjectFile {

    public void Decompile(Writer fout) {
	XobjectDecompileWriter out = makeDecompiler(fout);
	out.println("/* decompile from source="+ 
		    (sourceFileName == null ? "<unknown>" : sourceFileName)
		    + " */");

	if (headerLines != null)
	    for (int i = 0; i < headerLines.size(); i++)
		out.println((String)headerLines.elementAt(i));

	if (sourceFileName != null)
	    out.println("# 1 \"" + sourceFileName + "\"");

	out.printIdentList(getGlobalIdentList());

	for (XobjectDef d = getHead(); d != null; d = d.getNext())
	    out.print(d.getDef());

	if (tailerLines != null)
	    for(int i = 0; i < tailerLines.size(); i++)
		out.println((String)tailerLines.elementAt(i));

	out.flush();
    }

    protected XobjectDecompileWriter makeDecompiler(Writer fout) {
	return new XobjectDecompileWriter(fout, this);
    }
}
