package scmopt;

/**
  $B<0$NI>2A%/%i%9!#!J$G$C$A$"$2HG!#(B

  $B$^$@;n:nCJ3,$J$N$G!"@53N$JF0:n$O$7$^$;$s!#(B

  $B!&G[Ns$N07$$$OL$<BAu(B
  $B!&B?=EEAGE$,$"$k$H2x$7$$$3$H$K(B
  $B!&$=$NB>$$$m$$$m(B
 **/
import java.util.Vector;
import scm.*;
import exc.object.*;
import exc.block.*;



public class ExprEvaluater{
  
  final int INFO_NONE = 0;
  final int INFO_KNOWN = 1;
  final int INFO_UNKNOWN = 2;
//  final int INFO_ARRAY_UNKNOWN = 3;
  
  class ExprInfo{
    int state = 0;
    Xobject expr = null;
    Xobject val = null;
    Xobject val2 = null;
  }
  
  protected Vector m_exprs = new Vector();
  
  
  //Constructor
  public ExprEvaluater(){
    
  }
  
  public void init(){
    m_exprs.removeAllElements();
  }

  public boolean removeExpr(Xobject expr){
    for(int i = 0 ; i < m_exprs.size() ; i++){
      ExprInfo info = (ExprInfo)m_exprs.get(i);
      if(XTools.compareXobj(expr, info.expr)){
        m_exprs.remove(i);
      }
    }
    return true;
  }
  public boolean removeExpr(int index){
    m_exprs.remove(index);
    return true;
  }
  
  public boolean addExpr(Xobject expr, Xobject val, int state){
    if(expr == null) return false;
    if(XTools.searchXobj(val, expr) != null) state = INFO_UNKNOWN;
    
    boolean ret = true;
    
    
    //$BF1$8$b$N$,$9$G$K$"$k$+%A%'%C%/(B
    for(int i = 0 ; i < m_exprs.size() ; i++){
      ExprInfo info = (ExprInfo)m_exprs.get(i);
      if(XTools.compareXobj(info.expr, expr)){
        m_exprs.remove(i);
        break;
      }
    }
    
    //
    for(int i = 0 ; i < m_exprs.size() ; i++){
      ExprInfo info = (ExprInfo)m_exprs.get(i);
      if((info.val != null)&&
         (XTools.searchXobj(info.val, expr) != null)){
        
        info.state = INFO_UNKNOWN;
      }
      
      if((val != null) &&
         (XTools.searchXobj(val, info.expr) != null)){
        
        if(info.state == INFO_UNKNOWN){
          state = INFO_UNKNOWN;
        }else if(info.state == INFO_KNOWN){
          val = XTools.substituteXobj(val, info.expr, info.val);
        }
      }
    }
    
    
    ExprInfo newInfo = new ExprInfo();
    newInfo.expr = expr.copy();
    if(val != null)
      newInfo.val  = val.copy();
    
    newInfo.state = state;
    m_exprs.add(newInfo);
    
    return true;
  }

  
  public boolean addKnownExpr(Xobject expr, Xobject value){
    return addExpr(expr, value, INFO_KNOWN);
  }
  public boolean addUnknownExpr(Xobject expr){
    return addExpr(expr, null, INFO_UNKNOWN);
  }
  


  public Xobject evalExpr(Xobject expr){
    expr = expr.copy();
    
    for(int i = 0 ; i < m_exprs.size() ; i++){
      ExprInfo info = (ExprInfo)m_exprs.get(i);

      switch(info.state){
      case INFO_UNKNOWN:
        if(XTools.searchXobj(expr, info.expr) != null) return null;
        break;
      case INFO_KNOWN:
        expr = XTools.substituteXobj(expr, info.expr, info.val);
        break;
      }
    }
    
    
    return expr;
  }
  
  public boolean buildExprs(Xobject xobj){
    return buildExprs(xobj, false);
  }
  
  public boolean buildExprs(Xobject xobj, boolean branch){
    if(xobj == null) return true;

    int opcode = xobj.Opcode();
    boolean skipSubtree = false;
    if(xobj.isAsgOp()){
      skipSubtree = true;
      _processAsgOp(xobj, branch);
    }
    switch(opcode){
    case Xcode.IF_STATEMENT:
    case Xcode.FOR_STATEMENT:
    case Xcode.WHILE_STATEMENT:
      branch = true;
      break;
    }
    
    //$B$b$0$k(B -----------------------------------------------//
    if((!skipSubtree) && (xobj instanceof XobjList) && (opcode != Xcode.ID_LIST)){
      for(XobjArgs xArg = xobj.getArgs(); xArg != null ; xArg = xArg.nextArgs()){
        if(!buildExprs(xArg.getArg(), branch)) return false;
      }
    }
    return true;
  }
  private boolean _processAsgOp(Xobject xobj, boolean blanch){
    Xobject xLeft = xobj.left();
    Xobject xRight = xobj.right();
    
    if(!_isArray(xLeft)){
      if(!blanch){
        addKnownExpr(xLeft, xRight);
      }else{
        addUnknownExpr(xLeft);
      }
    }
    return true;
  }
  private boolean _isArray(Xobject xobj){
    return xobj.Opcode() == Xcode.POINTER_REF; //$B<jH4$-(B

    /* $B$&$^$/$$$+$J$+$C$?(B
    TopdownIterator iter = new TopdownIterator(xobj);
    for(iter.init() ; !iter.end() ; iter.next()){
      Xobject x = iter.get();
      if(x == null) continue;
      if(x.Opcode() == Xcode.POINTER_REF){
        iter.skipSubtree();
      }else if(x.isArrayAddr()){
        return true;
      }
    }
    return false;*/
  }
  
  public String toString(){
    StringBuffer buf = new StringBuffer();
    buf.append("ExprEvaluater has blow infomations\n");
    for(int i = 0 ; i < m_exprs.size() ; i++){
      ExprInfo info = (ExprInfo)m_exprs.get(i);
      switch(info.state){
      case INFO_KNOWN:
        buf.append(info.expr + " = " + info.val + "\n");
        break;
      case INFO_UNKNOWN:
        buf.append(info.expr + " = null\n");
        break;
      }
    }
    buf.append("----------------------- ExprEvaluater\n");
    return buf.toString();
  }
}

