package scmopt;

/*

 */

import java.util.*;
import scm.*;
import scmopt.*;
import exc.object.*;
import exc.block.*;

class IndexRange{
  String m_name; //z̖O
  int m_dim; //z̎
  
  Xobject[] m_xWMin = null;
  Xobject[] m_xWMax = null;
  
  Xobject[] m_xRMin = null;
  Xobject[] m_xRMax = null;
  
  boolean m_valid = false;
  
  Xobject[] m_xMin = null;
  Xobject[] m_xMax = null;
  
  Xobject[] m_xDif = null;
  
  int[] m_dif = null;
  boolean m_difConst = false;
  
  public IndexRange(String name, int dim){
    m_name = name;
    m_dim = dim;
    init();
  }
  public void init(){
    m_xWMin = new Xobject[m_dim];
    m_xWMax = new Xobject[m_dim];
    m_xRMin = new Xobject[m_dim];
    m_xRMax = new Xobject[m_dim];
  }
  ///////////////////////////////////////////////////////////// < accesser >
  public boolean isValid(){
    return m_valid;
  }
  public Xobject getWriteMax(int i){
    return m_xWMax[i];
  }
  public Xobject getWriteMin(int i){
    return m_xWMin[i];
  }
  public Xobject getReadMax(int i){
    return m_xRMax[i];
  }
  public Xobject getReadMin(int i){
    return m_xRMin[i];
  }
  public Xobject getMax(int i){
    return m_xMax[i];
  }
  public Xobject getMin(int i){
    return m_xMin[i];
  }
  public Xobject getDif(int i){
    return m_xDif[i];
  }
  public int getDifConst(int i){
    return m_dif[i];
  }
  public boolean difConst(){
    return m_difConst;
  }
  
  public Xobject[] getWriteMax(){
    return m_xWMax;
  }
  public Xobject[] getWriteMin(){
    return m_xWMin;
  }
  public Xobject[] getReadMax(){
    return m_xRMax; 
  }
  public Xobject[] getReadMin(){
    return m_xRMin;
  }
  public Xobject[] getDifs(){
    return m_xDif;
  }
  public boolean read(){
    return (m_valid) && (m_xRMin[0] != null);
  }
  public boolean written(){
    return (m_valid) && (m_xWMin[0] != null);
  }
  private void genDif(){
    
  }

  ///////////////////////////////////////////////////////////////// 
  public boolean process(Xobject xobj){
    ExprEvaluater eval = new ExprEvaluater();
    boolean ret = process(xobj, eval);
//    System.out.println(eval);
    return ret;
  }
  public boolean process(Xobject xobj, ExprEvaluater eval){
    m_valid = _process(xobj, new Vector(), false, eval);
    
    if(!m_valid){
      m_xMin = null;
      m_xMax = null;
      m_xDif = null;
      m_dif = null;
      m_difConst = false;
    }else{
      for(int i = 0 ; i < m_dim ; i++){
        if(m_xWMin[i] != null)
          m_xWMin[i] = XTools.reduceEasyIntOperation(m_xWMin[i]);
        if(m_xWMax[i] != null)
          m_xWMax[i] = XTools.reduceEasyIntOperation(m_xWMax[i]);
        if(m_xRMin[i] != null)
          m_xRMin[i] = XTools.reduceEasyIntOperation(m_xRMin[i]);
        if(m_xRMax[i] != null)
          m_xRMax[i] = XTools.reduceEasyIntOperation(m_xRMax[i]);
      }
      
      m_xMin = new Xobject[m_dim];
      m_xMax = new Xobject[m_dim];
      m_xDif = new Xobject[m_dim];
      m_dif  = new int    [m_dim];
      m_difConst = true;
      
      _margeMinMax(m_xWMin, m_xWMax, m_xRMin, m_xRMax, m_xMin, m_xMax, m_dim);
      
      if(m_xMin[0] != null){
        for(int i = 0 ; i < m_dim ; i++){
          m_xDif[i] = XTools.subXobjInt(m_xMax[i], m_xMin[i]);
          
          if((m_xDif[i] != null) && (m_xDif[i].Opcode() == Xcode.INT_CONSTANT)){
            m_dif[i] = m_xDif[i].getInt();
          }else{
            m_dif[i] = -1;
            m_difConst = false;
          }
        }
      }else{
        for(int i = 0 ; i < m_dim ; i++){
          m_xDif[i] = null;
          m_dif[i] = -1;
          m_difConst = false;
        }
      }
    }
    
    return m_valid;
  }
  private boolean _process(Xobject xobj, Vector xStack, boolean branch, ExprEvaluater eval){
    if(xobj == null) return true;

    int opcode = xobj.Opcode();
    boolean skipSubtree = false;
    
    //O -------------------------------------------------//
    switch(opcode){
    case Xcode.POINTER_REF:
      if(!_processPointerRef(xobj,xStack, branch, eval)) return false;
      break;
    case Xcode.IF_STATEMENT:
    case Xcode.WHILE_STATEMENT:
    case Xcode.SWITCH_STATEMENT:
      branch = true;
      break;
    case Xcode.FOR_STATEMENT:
      skipSubtree = true;
      if(!_processFor(xobj, xStack, branch, eval)) return false;
      break;
      
    }
    
    // -----------------------------------------------//
    if((!skipSubtree) && (xobj instanceof XobjList) && (opcode != Xcode.ID_LIST)){
      xStack.add(xobj);
      for(XobjArgs xArg = xobj.getArgs(); xArg != null ; xArg = xArg.nextArgs()){
        if(!_process(xArg.getArg(), xStack, branch, eval)) return false;
      }
      xStack.remove(xStack.size() - 1);
    }

    
    //㏈ -----------------------------------------------//
    if(xobj.isAsgOp()){
      eval.buildExprs(xobj, branch);
    }
    return true;
  }

  
  private boolean _processPointerRef(Xobject xobj, Vector xStack, boolean branch, ExprEvaluater eval){
    if(_isTargetArray(xobj)){
      //zCfbNX擾
      Xobject[] xIndexes = XTools.getIndexOfArray(xobj);
      if(xIndexes == null) {_fatal(); return false;}
      if(m_dim != xIndexes.length) {_fatal(); return false;}
      
      //ϐ`d{
      for(int i = 0 ; i < m_dim ; i++){
        if(xIndexes[i] != null)
          if((xIndexes[i] = eval.evalExpr(xIndexes[i])) == null) return false;
      }
      
      //݂ǂݍ݂̔
      Xobject xParent = (Xobject)xStack.get(xStack.size() - 1);
      if((xParent != null)&&(xParent.isAsgOp())&&(xParent.getArg(0) == xobj)){
        if(!_addNewIndex(m_xWMin, m_xWMax, xIndexes)) {_fatal(); return false;}
      }else{
        if(!_addNewIndex(m_xRMin, m_xRMax, xIndexes)) {_fatal(); return false;}
      }
    }
    return true;
  }

  
  private boolean _processFor(Xobject xobj, Vector xStack, boolean branch, ExprEvaluater eval){
    if((xobj == null)||(xobj.Opcode() != Xcode.FOR_STATEMENT)) {_fatal(); return false;}
    
    // analyze loop parameters --------------------//
    ForBlock forBlock = (ForBlock)Bcons.buildBlock(xobj);
    forBlock.Canonicalize();
    if(!forBlock.isCanonical()) {_fatal(); return false;}
    
    int step;
    Xobject xLoopVar = forBlock.getLoopVar();
    Xobject xUpperBound = forBlock.getUpperBound();
    Xobject xLowerBound = forBlock.getLowerBound();
    if((forBlock.getStep() == null)||(forBlock.getStep().Opcode() != Xcode.INT_CONSTANT)) {_fatal(); return false;}
    step = forBlock.getStep().getInt();
    
    //AYASHII
    if((step == 1)||(step == -1) ){
      xUpperBound = Xcons.binaryOp(Xcode.MINUS_EXPR, xUpperBound, Xcons.IntConstant(step));
    }
    
    // if upperbound < lowerbound  then swap.
    if(step < 0){
      Xobject t = xUpperBound;
      xUpperBound = xLowerBound;
      xLowerBound = t;
    }
    
    // analyze inner loop ------------------------//
    IndexRange range = new IndexRange(m_name, m_dim);
    if(!range.process(xobj.getArg(3))) return false;
    
    
    Xobject[] xwMin = range.getWriteMin();
    Xobject[] xwMax = range.getWriteMax();
    Xobject[] xrMin = range.getReadMin();
    Xobject[] xrMax = range.getReadMax();
    Xobject xLoopBody = xobj.getArg(3);
    
    // substitute inner loop indexes ------------------//
    for(int i = 0 ; i < m_dim ; i++){
      int wGrad, rGrad;
      if(range.written()){
        Xobject xGradWMin = XTools.getGradientInt(xwMin[i], xLoopVar);
        Xobject xGradWMax = XTools.getGradientInt(xwMax[i], xLoopVar);
        
        if((xGradWMin == null)||(xGradWMax == null)) {_fatal(); return false;}
        
        if((wGrad = xGradWMin.getInt()) != xGradWMax.getInt()) {_fatal(); return false;}
        if(wGrad > 0){
          xwMin[i] = XTools.substituteXobj(xwMin[i], xLoopVar, xLowerBound);
          xwMax[i] = XTools.substituteXobj(xwMax[i], xLoopVar, xUpperBound);
        }else if(wGrad < 0){
          xwMin[i] = XTools.substituteXobj(xwMin[i], xLoopVar, xUpperBound);
          xwMax[i] = XTools.substituteXobj(xwMax[i], xLoopVar, xLowerBound);
        }
      }
      if(range.read()){ 
        Xobject xGradRMin = XTools.getGradientInt(xrMin[i], xLoopVar);
        Xobject xGradRMax = XTools.getGradientInt(xrMax[i], xLoopVar);
        
        if((xGradRMin == null)||(xGradRMax == null)) {_fatal(); return false;}
        
        if((rGrad = xGradRMin.getInt()) != xGradRMax.getInt()) {_fatal(); return false;}
        
        if(rGrad > 0){
          xrMin[i] = XTools.substituteXobj(xrMin[i], xLoopVar, xLowerBound);
          xrMax[i] = XTools.substituteXobj(xrMax[i], xLoopVar, xUpperBound);
        }else if(rGrad < 0){
          xrMin[i] = XTools.substituteXobj(xrMin[i], xLoopVar, xUpperBound);
          xrMax[i] = XTools.substituteXobj(xrMax[i], xLoopVar, xLowerBound);
        }
      }
    }
    
    // ϐ`d{
    eval.buildExprs(xobj.getArg(0));
    for(int i = 0 ; i < m_dim ; i++){
      if(xwMin[i] != null)
        if((xwMin[i] = eval.evalExpr(xwMin[i])) == null) return false;
      if(xwMax[i] != null)
        if((xwMax[i] = eval.evalExpr(xwMax[i])) == null) return false;
      if(xrMin[i] != null)
        if((xrMin[i] = eval.evalExpr(xrMin[i])) == null) return false;
      if(xrMax[i] != null)
        if((xrMax[i] = eval.evalExpr(xrMax[i])) == null) return false;
      
    }
    
    if(!_margeMinMax(xwMin, xwMax, m_xWMin, m_xWMax, m_xWMin, m_xWMax, m_dim)) return false;
    if(!_margeMinMax(xrMin, xrMax, m_xRMin, m_xRMax, m_xRMin, m_xRMax, m_dim)) return false;
    
    
    return true;
  }
  private boolean _isTargetArray(Xobject xobj){
    TopdownIterator iter = new TopdownIterator(xobj);
    
    iter.init();
    for(iter.next(); !iter.end(); iter.next()){
      Xobject cx = iter.get();
      if(cx.Opcode() == Xcode.POINTER_REF) iter.skipSubtree();
      if(cx.isArrayAddr()){
        return m_name.equals(cx.getName());
      }
    }
    return false;
  }
  
  private static boolean _addNewIndex(Xobject[] xMin, Xobject[] xMax,
                                      Xobject[] xNewIndexes){
    for(int i = 0 ; i < xNewIndexes.length ; i++){
      if(xMin[i] == null){
        xMin[i] = xNewIndexes[i].copy();
        xMax[i] = xNewIndexes[i].copy();
      }else{
      
        int cmpMin = XTools.compareXobjInt(xNewIndexes[i], xMin[i]);
        int cmpMax = XTools.compareXobjInt(xMax[i], xNewIndexes[i]);
        
        if(cmpMin == XTools.COMPARE_LT){
          xMin[i] = xNewIndexes[i].copy();
        }else if(cmpMax == XTools.COMPARE_LT){
          xMax[i] = xNewIndexes[i].copy();
        }else if( (cmpMin == XTools.COMPARE_GT)&&(cmpMax == XTools.COMPARE_UNKNOWN ) ){
          {_fatal(); return false;}
        }else if( (cmpMax == XTools.COMPARE_GT)&&(cmpMin == XTools.COMPARE_UNKNOWN ) ){
          {_fatal(); return false;}
        }
          
      }
    }
    return true;
  }
  private static boolean _margeMinMax(Xobject[] min1, Xobject[] max1, Xobject[] min2, Xobject[] max2,
                                      Xobject[] retMin, Xobject[] retMax, int length){
    
    for(int i = 0 ; i < length ; i++){
      boolean valid1 = (min1[i] != null);
      boolean valid2 = (min2[i] != null);

      if(valid1 & valid2){
        int cmpMinMin = XTools.compareXobjInt(min1[i], min2[i]);
        int cmpMaxMax = XTools.compareXobjInt(max1[i], max2[i]);
        int cmpMinMax = XTools.compareXobjInt(min1[i], max2[i]);
        int cmpMaxMin = XTools.compareXobjInt(max1[i], min2[i]);
        
        
        if((cmpMinMax == XTools.COMPARE_GT)||(cmpMinMax == XTools.COMPARE_EQUAL)){
          retMin[i] = min2[i]; retMax[i] = max1[i];
        }else if((cmpMaxMin == XTools.COMPARE_LT)||(cmpMaxMin == XTools.COMPARE_EQUAL)){
          retMin[i] = min1[i]; retMax[i] = max2[i];
        }else if((cmpMinMin != XTools.COMPARE_UNKNOWN)||(cmpMaxMax != XTools.COMPARE_UNKNOWN)){
          if(cmpMinMin == XTools.COMPARE_GT){
            retMin[i] = min2[i];
          }else{
            retMin[i] = min1[i];
          }
          if(cmpMaxMax == XTools.COMPARE_GT){
            retMax[i] = max1[i];
          }else{
            retMax[i] = max2[i];
          }
        }else{
          {_fatal(); return false;}
        }
      }else if(  valid1 && (!valid2)){
        retMin[i] = min1[i]; retMax[i] = max1[i];
      }else if((!valid1) &&  valid2){
        retMin[i] = min2[i]; retMax[i] = max2[i];
      }else{
        retMin[i] = null; retMax[i] = null;
      }
    }
    return true;
  }
  
  private static void _fatal(){
    Thread.dumpStack();
  }
  
  public String toString(){
    StringBuffer buf = new StringBuffer();
    buf.append("ArrayName : " + m_name + ",  Dim : " + m_dim + "\n");
    for(int i = 0 ; i < m_dim ; i++){
      buf.append(i + "::  wMin:" + m_xWMin[i] + "   wMax:" + m_xWMax[i] + "\n");
      buf.append(i + "::  rMin:" + m_xRMin[i] + "   rMax:" + m_xRMax[i] + "\n");
    }
    return buf.toString();
  }
}
