package scmopt;

import java.util.Vector;
import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class OptNotReusable extends Optimizer {
  protected int        PAGE_SIZE;
  protected int        SCM_SIZE;
  
//  public static final boolean USE_SOFTWARE_PIPELINE = false;//scmf77.isOldFashion;
  
  protected boolean    m_allow_software_pipeline = false;
  protected int        m_stream_buf_size = 0;
  protected boolean    m_allow_branch = false;
  
  protected boolean    DEBUG=true; // DEBUG Flag
  
  
  protected Vector     sArrays  = new Vector(); // "String" 's array
  
  protected int        m_nOptArrays; // = sArrays.size()
  
  protected String[]   m_optNames = null; //z̖O
  protected int[]      m_optDims  = null; //z̎
  protected Xtype[]    m_optTypes = null; //ž^
  protected int[]      m_optTypeSize = null; //ž^̃oCg
  protected int[][]    m_optArraySize = null; //z̑傫
  
  
  protected int[][]    m_scmSize = null; //mۂSCMTCY
  protected int[][]    m_scmStride = null; //XgCh
  protected boolean[]  m_scmDoubleBuf = null; //_uobt@邩ǂ
  
  
  protected Xobject    m_xBody; //
  
  //œK@Ăꍇ
  protected int        m_method = 0;
  protected Xobject    m_xPlace = null;
  
  public OptNotReusable(Translater trans, Xobject xobj) {
    super(trans, xobj);
  
    /* Obtain Architecture-dependent Parameter Value */
    PAGE_SIZE= ScmParam.getDefaultParam(ScmParam.ON_CHIP_PAGE_SIZE);
    SCM_SIZE = ScmParam.getDefaultParam(ScmParam.ON_CHIP_MEM_SIZE);
    
    //    System.out.println(SCM_SIZE);

    if(!initOptCondition(xobj)) {/* error */}
    
  }
  
  
  /**
   * read conditions from "xobj"
   * conditions = var names, var types
   **/
  private boolean initOptCondition(Xobject xobj){
    Xobject t;
    
    // Canonicalize
    canonicalizeExpr canon = new canonicalizeExpr();
    xobj = canon.canonicalizeExpr(xobj);

    
    // find "SCM_PRAGMA" 
    TopdownIterator iter = new TopdownIterator(xobj);
    iter.init();
    while( ((t = iter.get()) == null) || (t.Opcode() != Xcode.SCM_PRAGMA) ){
      iter.next();
    }
    
    xobj = t;
    
    // read opt var name
    for(;;){
      if( (xobj != null) && (xobj.Opcode() == Xcode.SCM_PRAGMA) ){
        if(xobj.getArg(0).getName().equals("opt_notreusable_")){
          sArrays.addElement(xobj.getArg(1).getName());
        }else{
//          return false;
	    break;
        }
      }else{
        break;
      }
      xobj = xobj.getArg(xobj.Nargs() - 1);
    }
    if(xobj == null) return false;
    m_xBody = xobj;
    
    
    
    // check other "SCM_PRAGMA" do not exist
    // if other "SCM_PRAGMA" exist, we cannot optimize
    for( iter.init(xobj); !iter.end(); iter.next() ){
      if(((t = iter.get()) != null) && (t.Opcode() == Xcode.SCM_PRAGMA )){
		
        if(t.getArg(0).getName().equals("option_")){ 
          String name = t.getArg(1).getName();
          
          if(name.equals("software_pipeline_")){
            m_allow_software_pipeline = true;
          }else if(name.equals("stream_buf_size_")){
            m_stream_buf_size = t.getArg(2).getArg(0).getInt();
          
          }else if(name.equals("software_pipeline_here_")){
             m_method = 1;
             m_xPlace = iter.getParent();
          }
          iter.remove();
          
        }else{
          fatal("Cannot optimize at #" + xobj.getLineNo().lineNo() + 
                ". In \"opt_notreusable\" other scm_directive cannot use.");
          return false;
        }
      }
    }
    
    
    
    //organize array infomation
    m_nOptArrays = sArrays.size(); // # of NotReusable Array
    m_optNames      = new String [m_nOptArrays];
    m_optDims       = new int    [m_nOptArrays];
    m_optTypes      = new Xtype  [m_nOptArrays];
    m_optTypeSize   = new int    [m_nOptArrays];
    m_optArraySize  = new int    [m_nOptArrays][];
    m_scmSize       = new int    [m_nOptArrays][];
    m_scmStride     = new int    [m_nOptArrays][];
    m_scmDoubleBuf  = new boolean[m_nOptArrays];
    
    for(int i = 0 ; i < m_nOptArrays ; i++){
      m_optNames[i] = (String)sArrays.get(i);
      m_optTypes[i] = trans.findCommonVariable(m_optNames[i]).Type();
      m_optDims[i] = m_optTypes[i].getNumDimensions();
      m_optTypeSize[i] = m_optTypes[i].getArrayElementType().getSize();

      m_optArraySize[i] = new int[m_optDims[i]];
      
      m_scmSize[i]   = new int[m_optDims[i]];
      m_scmStride[i] = new int[m_optDims[i]];
      m_scmDoubleBuf[i] = false;
      
      Xtype type = m_optTypes[i];
      for(int j = 0 ; j < m_optDims[i] ; j++){
        m_optArraySize[i][j] = type.getArrayDim();
        type = type.getRef();
        
        m_scmSize[i][j] = 0;
        m_scmStride[i][j] = 0;
      }
    }
    
    
    if(DEBUG)System.out.println("sArrays = "+ sArrays);
    
    return true;
    
  }
  
  boolean reserveScmArea(int[][] scmSize, boolean[] doubleBuf){
    int nUsedPage = 0;
    
    for(int i = 0 ; i < m_nOptArrays ; i++){
      int size = m_optTypeSize[i];

      for(int j = 0 ; j < m_optDims[i] ; j++){
        if(scmSize[i][j] > m_scmSize[i][j]){
          size *= scmSize[i][j];
        }else{
          size *= m_scmSize[i][j];
        }
      }

      if(doubleBuf[i] || m_scmDoubleBuf[i])
        size *= 2;
      
      nUsedPage += (size + PAGE_SIZE - 1) / PAGE_SIZE;
    }
    
    if(nUsedPage > SCM_SIZE / PAGE_SIZE) return false;
    
    for(int i = 0 ; i < m_nOptArrays ; i++){
      for(int j = 0 ; j < m_optDims[i] ; j++){
        if(scmSize[i][j] > m_scmSize[i][j]){
          m_scmSize[i][j] = scmSize[i][j];
        }
      }
      m_scmDoubleBuf[i] = m_scmDoubleBuf[i] || doubleBuf[i];
    }
    return true;
  }
  
  boolean getArrayIndexUpperRange(Xobject xRoot, int i,
                                  Xobject[] xRetMin, int[] retDif, boolean[] retReadWrite){
    
    IndexRange range = new IndexRange(m_optNames[i], m_optDims[i]);
    if(!range.process(xRoot)) return false;

    retReadWrite[0] = range.read();
    retReadWrite[1] = range.written();
    
    if(range.read() || range.written()){
      for(int j = 0 ; j < m_optDims[i] ; j++){
        if(range.getDif(j).Opcode() != Xcode.INT_CONSTANT){
          if(m_optArraySize[i][j] > 0)
            retDif[j] = m_optArraySize[i][j] - 1;
          else
            return false;
        }else{
          retDif[j] = range.getDif(j).getInt();
        }
        xRetMin[j] = range.getMin(j);
        
      }
    }else{
      for(int j = 0 ; j < m_optDims[i] ; j++) retDif[j] = 0;
    }

    return true;
  }
  
  
  public boolean doOptimize(Xobject xobj, XobjModifier modif){
    if(doStripMine(xobj, modif)) return true;
    if(doBasic(xobj, modif)) return true;
    return false;
  }
  
  
  
  public Xobject genOpt(){
    if(DEBUG)
      System.out.println("Start optimize ... in scm.opt.OptNotReusable");
    
    //initialize "XobjModifier"
    XobjModifier modif = new XobjModifier(m_xBody, this);
    
    
    // *******************************************************< check code >
/*    
    for(int i = 0 ; i < m_nOptArrays ; i++){
      IndexRange range = new IndexRange(m_optNames[i], m_optDims[i]);
      range.process(m_xBody);
      System.out.println(range);
    }
    System.exit(0);
*/
    // *************************************************************
    
    if(m_method == 0){ //œK
      //œK͈͂̌
      if(!doOptimize(m_xBody, modif)){
        TopdownIterator iter;
        iter = new TopdownIterator(m_xBody);
        for(iter.init() ; !iter.end() ; iter.next()){
          Xobject x = iter.get();
          if(x == null) continue;
          if(x.Opcode() == Xcode.FOR_STATEMENT){
            if(doOptimize(x, modif)) break;
            if(doOptimize(x.getArg(3), modif)) break;
          }
        }
      }
      
      
      
      for(int i = 0 ; i < m_nOptArrays ; i++){
        boolean flag = false;
        for(int j = 0 ; j < m_optDims[i] ; j++){
          if(m_scmSize[i][j] == 0) {flag = true; break; }
        }
        if(flag) continue;
        
        if(m_scmDoubleBuf[i]){
          modif.insertPbegin(m_optNames[i], m_scmSize[i], m_scmStride[i]);
        }else{
          modif.insertBegin(m_optNames[i], m_scmSize[i], m_scmStride[i]);
        }
      }
      
    }else if(m_method == 1){//\tgEFApCvC
      softwarePipelineHere(m_xPlace, modif);
    }
    
    if(DEBUG) XTools.printXObj(modif.getRoot());
  
    // System.exit(0);
  
    return modif.getRoot();
  }

  
  void softwarePipelineHere(Xobject xPlace, XobjModifier modif){
    Xobject xFor = null; 
    
    TopdownIterator iter = new TopdownIterator(xPlace);
    for(iter.init(); !iter.end() ; iter.next()){
      Xobject x = iter.get();
      if(x == null) continue;
      if(x.Opcode() == Xcode.FOR_STATEMENT){
        xFor = x;
        break;
      }
    }
    
    Xobject xLoopBody = xFor.getArg(3);
    IndexRange[] range = new IndexRange[m_nOptArrays];
    for(int i = 0 ; i < m_nOptArrays ; i++){
      range[i] = new IndexRange(m_optNames[i], m_optDims[i]);
      range[i].process(xLoopBody);
    }
    
    
    boolean[] doubleBuf = new boolean[m_nOptArrays];
    for(int i=0 ; i < m_nOptArrays ; i++){
      doubleBuf[i] = true;
    }
    
    Xobject xNew = modif.softwarePipeline(xFor, m_optNames, m_optDims, doubleBuf);
    
    for(int i = 0 ; i < m_nOptArrays ; i++){
      Xobject[] xScmSize = new Xobject[m_optDims[i]];
      for(int j = 0 ; j < m_optDims[i] ; j++){
        xScmSize[j] = XTools.addXobjInt(Xcons.IntConstant(1), range[i].getDif(j));
      }
      
      modif.insertPbegin(modif.getRoot(), m_optNames[i], xScmSize, m_scmStride[i]);
      
    }
  }
  
  
  // -------------------------------------------------------< strip mine >
  boolean doStripMine(Xobject xobj, XobjModifier modif){
    
    if(xobj.Opcode() != Xcode.FOR_STATEMENT) return false;
    
    boolean softPipe = m_allow_software_pipeline;

    int linesize = m_stream_buf_size;
    if(linesize == 0){
      linesize = PAGE_SIZE;
    }
    
    //ϐ
    int[][]   scmSize   = new     int[m_nOptArrays][];
    boolean[] doubleBuf = new boolean[m_nOptArrays];
    for(int i = 0 ; i < m_nOptArrays ; i++){
      scmSize[i] = new int[m_optDims[i]];
      for(int j = 0 ; j < m_optDims[i] ; j++) scmSize[i][j] = 0;
      doubleBuf[i] = false;
    }
    
    //[v擾
    ForBlock forBlock = (ForBlock)Bcons.buildBlock(xobj);
    forBlock.Canonicalize();
    if(!forBlock.isCanonical()) return false;
    Xobject xLoopVar = forBlock.getLoopVar();
    Xobject xBody = xobj.getArg(3);
    
    boolean effective = false;
    int stepSize = PAGE_SIZE; // big number
    for(int i = 0 ; i < m_nOptArrays ; i++){
      IndexRange range = new IndexRange(m_optNames[i], m_optDims[i]);
      if(!range.process(xBody)) return false;
      
      if(!(range.read() || range.written())) continue;
      
      if(!range.difConst()) return false;
      
      for(int j = 0 ; j < m_optDims[i] ; j++){
        
        Xobject xCoef = XTools.getGradientInt(range.getMin(j), xLoopVar);
        if(xCoef == null) {Thread.dumpStack(); return false;}
        
        if(xCoef.getInt() == 0){
          scmSize[i][j] = range.getDifConst(j) + 1;
        }else if((xCoef.getInt() == 1) || (xCoef.getInt() == -1)){
          scmSize[i][j] = linesize / m_optTypeSize[i];
          if(j == 0) effective = true;
          int t = linesize / m_optTypeSize[i] - range.getDifConst(j);
          if(stepSize > t) stepSize = t;
        }else{
          Thread.dumpStack();
          return false;
        }
      }
      
      //_uobt@Osǂ
      if(m_allow_software_pipeline)
        doubleBuf[i] = true;
    }

    //݂̏ōœKsǂBœKȂꍇ return false
    if(!effective) return false;
    if(!reserveScmArea(scmSize, doubleBuf)){
      softPipe = false;
      for(int i = 0 ; i < m_nOptArrays ; i++){
        doubleBuf[i] = false;
      }
      if(!reserveScmArea(scmSize, doubleBuf)){
        return false;
      }
    }

    //œKJn
    Xobject xOptLoop = modif.loopStripMine(xobj, Xcons.IntConstant(stepSize));
    
    Xobject xInsertLoadBody = xOptLoop.getArg(3).getArg(1);

    if(!softPipe){
      Xobject xNew = modif.analyzeAndInsertLoadStore(xInsertLoadBody, m_optNames, m_optDims);
    }else{
      Xobject xNew = modif.softwarePipeline(xOptLoop, m_optNames, m_optDims, doubleBuf);
    }
    return true;
  }
  // ---------------------------------------------------------< basic method >
  boolean doBasic(Xobject xobj, XobjModifier modif){
    boolean softPipe = m_allow_software_pipeline;
    
    //ϐ
    int[][]   scmSize   = new     int[m_nOptArrays][];
    boolean[] doubleBuf = new boolean[m_nOptArrays];
    for(int i = 0 ; i < m_nOptArrays ; i++){
      scmSize[i] = new int[m_optDims[i]];
      for(int j = 0 ; j < m_optDims[i] ; j++) scmSize[i][j] = 0;
      doubleBuf[i] = false;
    }
    
    //͈͓̔zANZXp^[̎擾
    for(int i = 0 ; i < m_nOptArrays ; i++){
      Xobject[] xIndexMin = new Xobject[m_optDims[i]];
      boolean[] readWrite = new boolean[2];
      
      if(!getArrayIndexUpperRange(xobj, i,
                                  xIndexMin, scmSize[i], readWrite)) return false;
      
      if(readWrite[0] || readWrite[1]){
        //        doubleBuf[i] = softPipe;
        for(int j = 0 ; j < m_optDims[i] ; j++){
          scmSize[i][j]++;
        }
      }
    }
    
    //݂̏ōœKsǂBœKȂꍇ return false
    if(!reserveScmArea(scmSize, doubleBuf)){
//      softPipe = false;
//      for(int i = 0 ; i < m_nOptArrays ; i++){
//        doubleBuf[i] = false;
//      }
//      if(!reserveScmArea(scmSize, doubleBuf)){
        return false;
//      }
    }
    
    
//    if(!softPipe){
      Xobject xNew = modif.analyzeAndInsertLoadStore(xobj, m_optNames, m_optDims);
//    }else{
//      Xobject xNew = modif.softwarePipeline(xOptLoop, m_optNames, m_optDims, doubleBuf);
//    }
    
    return true;
  }
  
  
  /*
  //ꍇ킯strip mine
  // -------------------------------------------------------< strip mine >
  boolean doStripMine2(Xobject xobj, XobjModifier modif){
    if(xobj.Opcode() != Xcode.FOR_STATEMENT) return false;
    if(!m_allow_software_pipeline) return false;
    if(!m_allow_branch) return false;
    
    
    //ϐ
    int[][]   scmSize   = new     int[m_nOptArrays][];
    boolean[] doubleBuf = new boolean[m_nOptArrays];
    for(int i = 0 ; i < m_nOptArrays ; i++){
      scmSize[i] = new int[m_optDims[i]];
      for(int j = 0 ; j < m_optDims[i] ; j++) scmSize[i][j] = 0;
      doubleBuf[i] = false;
    }
    
    //[v擾
    ForBlock forBlock = (ForBlock)Bcons.buildBlock(xobj);
    forBlock.Canonicalize();
    if(!forBlock.isCanonical()) return false;
    Xobject xLoopVar = forBlock.getLoopVar();
    Xobject xBody = xobj.getArg(3);
    
    boolean effective = false;
    int stepSize = PAGE_SIZE; // big number
    for(int i = 0 ; i < m_nOptArrays ; i++){
      IndexRange range = new IndexRange(m_optNames[i], m_optDims[i]);
      if(!range.process(xBody)) return false;
      
      if(!(range.read() || range.written())) continue;
      
      if(!range.difConst()) return false;
      
      for(int j = 0 ; j < m_optDims[i] ; j++){
        
        Xobject xCoef = XTools.getGradientInt(range.getMin(j), xLoopVar);
        if(xCoef == null) {Thread.dumpStack(); return false;}
        
        if(xCoef.getInt() == 0){
          scmSize[i][j] = range.getDifConst(j) + 1;
        }else if((xCoef.getInt() == 1) || (xCoef.getInt() == -1)){
          scmSize[i][j] = PAGE_SIZE / m_optTypeSize[i];
          if(j == 0) effective = true;
          int t = PAGE_SIZE / m_optTypeSize[i] - range.getDifConst(j);
          if(stepSize > t) stepSize = t;
        }else{
          Thread.dumpStack();
          return false;
        }
      }
      
      //_uobt@Osǂ
      doubleBuf[i] = true;
    }
    
    //݂̏ōœKsǂBœKȂꍇ return false
    if(!effective) return false;
    if(!reserveScmArea(scmSize, doubleBuf)){
      return false;
    }
    
    //œKJn
    Xobject xOptLoop = modif.loopStripMine(xobj, Xcons.IntConstant(stepSize));
    
    Xobject xInsertLoadBody = xOptLoop.getArg(3).getArg(1);
    
    if(!softPipe){
      Xobject xNew = modif.analyzeAndInsertLoadStore(xInsertLoadBody, m_optNames, m_optDims);
    }else{
      Xobject xNew = modif.softwarePipeline(xOptLoop, m_optNames, m_optDims, doubleBuf);
    }
    return true;
  }
*/



}
