package scmopt;

import java.util.Vector;
import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class OptReusable extends Optimizer {
  protected Vector     sArrays = new Vector();
  protected Translater translater;
  protected XobjList   LoopVarList;
  protected XobjList   StepList;
  protected XobjList   elemLoopVarList;
  protected XobjList   elemStepList;
  protected int        NumOfReusableArray;
  protected int        BlockSize;
  
  public OptReusable(Translater trans, Xobject xobj) {
    super(trans, xobj);
    translater = trans;

    do {
      if (xobj.Opcode() == Xcode.SCM_PRAGMA){
	if (xobj.getArg(0).getName().equals("opt_reusable_")){
	  sArrays.addElement(xobj.getArg(1).getName());
	  xobj = xobj.getArg(3);
	}
      }
      else{
	xobj = xobj.getArg(0); // 0 or 1
      }
    }while(xobj.Opcode() != Xcode.FOR_STATEMENT);
    
    super.xobj = xobj;
    NumOfReusableArray = sArrays.size();

    //Temporary
    BlockSize = ScmParam.getDefaultParam(ScmParam.ON_CHIP_MEM_SIZE)/8;
    System.out.println("BlockSize=" + BlockSize);
  }

  public Xobject genOpt2(){
    canonicalizeExpr canon = new canonicalizeExpr();
    xobj = canon.canonicalizeExpr(xobj);

    /**
     *  Blocking Loop Analyze
     */
    TopdownIterator analyzer   = new TopdownIterator(xobj);
    analyzer.init();   // for BlockingLoops

    LoopVarList = new XobjList();
    StepList    = new XobjList();
    do{
      xobj = analyzer.get();
      if ((xobj.Opcode() == Xcode.FOR_STATEMENT)){
	//LoopVarList.add(xobj.getArg(0).getArg(2).getArg(0));
	LoopVarList.add(xobj.getArg(2).getArg(0));
	//StepList.add(xobj.getArg(0).getArg(0).getArg(1));	
	StepList.add(xobj.getArg(0).getArg(1));
      }
      else{
      };
      analyzer.next();
    }while(xobj.Opcode() != Xcode.SCM_PRAGMA);

    System.out.println(LoopVarList);

    analyzer.moveUp(); // go back; (remove not-used SCM_PRAGMA)

    XobjList elemLoop;
    elemLoop = new XobjList();
    elemLoop.add(xobj.getArg(3));


    //xobj = xobj.getArg(3).getArg(1);  xobj must begin with FOR Statement
    xobj = xobj.getArg(3);  // xobj must begin with FOR Statement

    ForBlock fb = (ForBlock) Bcons.buildBlock(xobj);

    BlockList elemb;
    elemb = new BlockList();
    elemb.add(elemLoop.getArg(0));

    /**
     *   Element Loop Analyze
     */

    Xobject tmp = fb.toXobject();
    TopdownIterator analyzer2 = new TopdownIterator(tmp);
    analyzer2.init();

    ForBlock tmpfb;

    elemLoopVarList = new XobjList();

    do{
      tmp = analyzer2.get();
      if ((tmp.Opcode() == Xcode.FOR_STATEMENT)){
	tmpfb = (ForBlock) Bcons.buildBlock(tmp);
       	tmpfb.Canonicalize();
	elemLoopVarList.add(tmpfb.getLoopVar());
      }
      else{
      };
      analyzer2.next();
    }while(analyzer2.end() == false);

    /**
     *  Insertion of !$scm load/!$scm store pragma
     * (pragma insertion level modification is not(yet) supported)
     */
  
    insertPragmas inspragma = new insertPragmas();

    int i;
    int i2;
    int dim;

    Xobject xload  = null;
    Xobject xstore = null;
    Block bload    = Bcons.Statement(xload);
    Block bstore   = Bcons.Statement(xstore);
    BlockList bl;   //= fb.getBody();

    Xobject[] lindexlist;
    Xobject[] lsizelist;
    XobjList  llist;
  
    for (i2=0; i2 < sArrays.size(); i2++){
      dim = translater.findCommonVariable(sArrays.elementAt(i2).toString())
	.Type().getNumDimensions();

      lindexlist = new Xobject[dim];
      lsizelist  = new Xobject[dim];
      llist      = new XobjList();

      /* !! Mulmat Special !! */
      if(sArrays.elementAt(i2).toString().equals("x_")){
	lindexlist[0] = LoopVarList.getArg(0);
	lindexlist[1] = LoopVarList.getArg(2);
	llist.add(lindexlist[0]);
	llist.add(lindexlist[1]);
      }
      if(sArrays.elementAt(i2).toString().equals("y_")){
	lindexlist[0] = LoopVarList.getArg(2);
	lindexlist[1] = LoopVarList.getArg(1);
	llist.add(lindexlist[0]);
	llist.add(lindexlist[1]);
      }
      if(sArrays.elementAt(i2).toString().equals("z_")){
	lindexlist[0] = LoopVarList.getArg(0);
	lindexlist[1] = LoopVarList.getArg(1);
	llist.add(lindexlist[0]);
	llist.add(lindexlist[1]);
      }
      /* !! Mulmat Special !! */
      lsizelist[0] = StepList.getArg(0);
      llist.add(lsizelist[0]);

      if (dim > 1){
	for (i=1; i < dim; i++){
	  lsizelist[i] = StepList.getArg(i);
	  llist.add(lsizelist[i]);
	}
      }

      xload  = inspragma.insertLoad(sArrays.elementAt(i2).toString(), llist);
      xstore = inspragma.insertStore(sArrays.elementAt(i2).toString());
      bload  = Bcons.Statement(xload);
      bstore = Bcons.Statement(xstore);

      if(sArrays.elementAt(i2).toString().equals("z_") == false){
	//	elemb.add(bstore);
      elemb.insert(bload); /* !!Mulmat Special!! */
      }
    }
    analyzer.substitute(elemb.toXobject());

    /**
     *  Insertion of !$scm load/!$scm store pragma
     * (pragma insertion level modification)
     
    Xobject tmp2;
    tmp2 = analyzer.get();
    do{
      analyzer.moveUp();
      tmp2 = analyzer.get();
    }while(tmp2.Opcode() != Xcode.FOR_STATEMENT);

    System.out.println(tmp2.Opcode() == Xcode.FOR_STATEMENT);

    XobjList elemLoop2;
    elemLoop2 = new XobjList();
    elemLoop2.add(tmp2);

    BlockList elemb2;
    elemb2 = new BlockList();
    elemb2.add(elemLoop2.getArg(0));

  
    insertPragmas inspragma2 = new insertPragmas();

    xload  = null;
    xstore = null;
    Block bload2    = Bcons.Statement(xload);
    Block bstore2   = Bcons.Statement(xstore);
    
    Xobject[] lindexlist2;
    Xobject[] lsizelist2;
    XobjList  llist2;
  
    lindexlist2 = new Xobject[4];
    lsizelist2  = new Xobject[4];
    llist2      = new XobjList();

    lindexlist2[0] = LoopVarList.getArg(0);
    lindexlist2[1] = LoopVarList.getArg(1);
    llist2.add(lindexlist2[0]);
    llist2.add(lindexlist2[1]);

    lsizelist2[0] = StepList.getArg(0);
    lsizelist2[1] = StepList.getArg(1);
    llist2.add(lsizelist2[0]);
    llist2.add(lsizelist2[1]);

    xload  = inspragma2.insertLoad("z", llist2);
    xstore = inspragma2.insertStore("z");
    bload2  = Bcons.Statement(xload);
    bstore2 = Bcons.Statement(xstore);

    elemb2.add(bstore);
    elemb2.insert(bload);

    analyzer.substitute(elemb2.toXobject());  

    xobj = analyzer.getRoot();
    */
    /**
     *   Insertion of !$scm begin pragma
     */
    Xobject[] bsizelist;
    Xobject[] bstridelist;
    XobjList  blist;

    System.out.println("neko");

    for (i2 = 0; i2 < sArrays.size(); i2++){
      dim = translater.findCommonVariable(sArrays.elementAt(i2).toString())
	.Type().getNumDimensions();
      bsizelist   = new Xobject[dim];
      bstridelist = new Xobject[dim];
      blist       = new XobjList();
      
      bsizelist[0] = StepList.getArg(0);
      blist.add(bsizelist[0]);
      if (dim > 1){
	for (i = 1; i < dim; i++){
	  bsizelist[i] = StepList.getArg(i);
	    blist.add(bsizelist[i]);
	}
      }
      
      for (i = 0; i < dim; i++ ){
	bstridelist[i] = Xcons.IntConstant(0);
	blist.add(bstridelist[i]);
      }
      
      xobj = inspragma.insertBegin(sArrays.elementAt(i2).toString(),
				   blist, xobj);
    }
    return xobj;
  }
}
