package scmopt;

import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class Optimizer {
  Translater trans;
  Xobject xobj;

  int temp_counter = 0;

  public Optimizer(Translater trans, Xobject xobj) {
    this.trans = trans;
    this.xobj  = xobj;
  }

  public Xobject genOpt() {
    warn("Not implemented yet. Optimization aborted.");
    return xobj;
  }

  public Xobject genOpt2() {
    warn("Not implemented yet. Optimization aborted.");
    return xobj;
  }

  protected boolean isForStatement(Xobject x) {
      if (x.Opcode() == Xcode.FOR_STATEMENT)
	  return true;
      else
	  return false;
  }

  public void addIdList(String var, Xtype t){
    addIdList(Ident.Local(var, t));
  }

  public void addIdList(Ident id){
    Xobject id_list = trans.getIdList();
    if (!isDeclared(id_list, id))
      id_list.add(id);
  }

  public boolean isDeclared(Xobject id_list, Ident id){
    for (XobjArgs a = id_list.getArgs(); a != null; a = a.nextArgs()){
      if (a.getArg().getName().equals(id.getName()))
	return true;
    }
    return false;
  }

  /*
  public Xobject newTempVar(String s, Xtype t){     
    Ident id = Ident.Local(s, t);
    addIdList(id);
    return Xcons.List(Xcode.POINTER_REF, t, id.getValue());
  }
  */

  public Ident newTempVar(Xtype t){
    Ident id = Ident.TempVar(temp_counter++, t);
    addIdList(id);
    return id;
  }

  static void fatal(String msg){
    System.err.println("Fatal <SCM Opt>: " + msg);
    Thread.dumpStack();
    System.exit(1);
  }

  static void warn(String msg){
    System.err.println("Warning <SCM Opt>: " + msg);
  }

}
