package scmopt;

/*
 Xobject Analyzer
  
  XIuWFNgoĂ܂Ƃ߂菕NXÂ͂B
  
 */

import java.util.*;
import scm.*;
import scmopt.*;
import exc.object.*;
import exc.block.*;

public class XTools{
  public static Xobject getGradientInt(Xobject xExpr, Xobject xVar){
    Vector varTerms = new Vector();
    Vector varCoef  = new Vector();
    
    correctIntTerm(xExpr, varTerms, varCoef);
    
    for(int i = 0 ; i < varTerms.size() ; i++){
      Xobject xTerm = (Xobject)varTerms.get(i);
      if(compareXobj(xVar, xTerm)){
        return ((Xobject)varCoef.get(i));
      }else{
        if(searchXobj(xTerm, xVar) != null){
          return null;
        }
      }
    }

    return Xcons.IntConstant(0);
  }

  
  public static int COMPARE_EQUAL = 0;
  public static int COMPARE_GT    = 1; //x1 > x2
  public static int COMPARE_LT    = 2; //x1 < x2
  public static int COMPARE_UNKNOWN = 3;
  public static int compareXobjInt(Xobject x1, Xobject x2){
    Xobject x = subXobjInt(x1, x2);

    if(x == null) return COMPARE_UNKNOWN;

    if(x.Opcode() == Xcode.INT_CONSTANT){
      int xInt = x.getInt();

      if(xInt > 0)
        return COMPARE_GT;
      else if(xInt < 0)
        return COMPARE_LT;
      else if(xInt == 0)
        return COMPARE_EQUAL;
    }

    return COMPARE_UNKNOWN;
  }
  
  
  private static void _fatal(){
    Thread.dumpStack();
  }
  
  



  /**
   * Get indexes of Array.
   * @param root obtain expresssion of array. root.Opcode() == POINTER_REFK{
   **/
  public static Xobject[] getIndexOfArray(Xobject root){
    //check parameter.
    if(root == null) return null;
    if(root.Opcode() != Xcode.POINTER_REF) return null;
    
    //Enunciation
    TopdownIterator iterator = new TopdownIterator(root);
    Xobject cx = null; //current xobject
    Xobject bx = null; //before xobject
    Vector indexes = new Vector();
    
    //Search "array addr" from [root] 
    iterator.init();
    for(;;){
      iterator.next();
      if(iterator.end()) return null;
      
      cx = iterator.get();
      if(cx.Opcode() == Xcode.POINTER_REF) iterator.skipSubtree();
      if(cx.isArrayAddr()) break;
    }
    
    for(;;){
      int parentOp = iterator.getParent().Opcode();
      if((parentOp == Xcode.ARRAY_AREF)||(parentOp == Xcode.POINTER_REF)){
        
        if(cx.Opcode() != Xcode.PLUS_EXPR) return null;
        
        if(cx.getArg(1) == bx){
          indexes.add(cx.getArg(0));
        }else{
          indexes.add(cx.getArg(1));
        }
        
        if(parentOp == Xcode.POINTER_REF) break;
      }
      
      bx = cx;
      iterator.moveUp();
      cx = iterator.get();
    }
    
    if(indexes.size() == 0) return null;
    
    Xobject[] ret = new Xobject[indexes.size()];
    for(int i = 0 ; i < indexes.size() ; i++){
      ret[indexes.size() - i - 1] = (Xobject)indexes.get(i);
    }
    
    return ret;
  }
  
  /**
   * root̒exprTB
   * 
   **/
  public static Xobject searchXobj(Xobject xRoot, Xobject xExpr){
    TopdownIterator iter = new TopdownIterator(xRoot);
    for(iter.init(); !iter.end() ; iter.next()){
      Xobject x = iter.get();
      if(x == null)continue;

      if(compareXobj(xExpr, x)) return x;
    }
    
    return null;
  }

  /**
   * xRoot ̒xOldׂxNewɒu
   **/
  public static Xobject substituteXobj(Xobject xRoot, Xobject xOld, Xobject xNew){
    xRoot = xRoot.copy();
    
    if(compareXobj(xRoot, xOld)) return xNew;
    
    TopdownIterator iter = new TopdownIterator(xRoot);
    for(iter.init(); !iter.end() ; iter.next()){
      Xobject x = iter.get();
      if(x == null)continue;
      
      if(compareXobj(xOld, x)){
        iter.substitute(xNew.copy());
        iter.skipSubtree();
      }
    }
    
    return xRoot;
  }
  

  /**
   * compare two xobjects.
   * equals return "true". not equals return "false".
   * Xobject.equals()_Ȕr@\B
   **/
  public static boolean compareXobj(Xobject x1, Xobject x2){
    boolean r = x1.equals(x2);
//    System.out.println("compareXobj : " + x1 + " == " + x2 + " = " + r );
    return r;
  }
  
  /**
   * xRoot̒AsIterCe[^[Ƃ郋[vTB
   * ꍇ͍ŏɌ
   **/
  public static Xobject searchForLoop(Xobject xRoot, String sIter){
    TopdownIterator iter = new TopdownIterator(xRoot);

    for(iter.init() ; !iter.end() ; iter.next()){
      Xobject xc = iter.get();
      
      if((xc != null)&&(xc.Opcode() == Xcode.FOR_STATEMENT)){
        Block b = Bcons.buildBlock(xc);
        if(!(b instanceof ForBlock)) continue;

        ForBlock fb = (ForBlock)b;
        fb.Canonicalize();

        if(!fb.isCanonical()) continue;
        
        if(sIter.equals(fb.getLoopVar().getName())){
          return xc;
        }
      }
    }
    return null;
  }
  /**
   * reduce subscription x1 - x2;
   **/
  public static Xobject subXobjInt(Xobject x1, Xobject x2){
    return reduceEasyIntOperation(Xcons.binaryOp(Xcode.MINUS_EXPR, x1, x2));
  }
  /**
   * reduce addtion x1 + x2;
   **/
  public static Xobject addXobjInt(Xobject x1, Xobject x2){
    return reduceEasyIntOperation(Xcons.binaryOp(Xcode.PLUS_EXPR, x1, x2));
  }
  
  /**
   * ȒPɂ
   **/
  public static Xobject reduceEasyIntOperation(Xobject xExpr){
    Vector varTerms = new Vector();
    Vector varCoef  = new Vector();
    
    //
    correctIntTerm(xExpr, varTerms, varCoef);
    
    
    //create return xobject
    Xobject xRet = null;
    
    
    for(int i = 0 ; i < varTerms.size() ; i++){
      Xobject term = (Xobject)varTerms.get(i);
      Xobject coef = (Xobject)varCoef.get(i);

      if(coef.getInt() == 0) continue;
      
      Xobject term2 = null;
      if(coef.getInt() == 1){
        term2 = term;
      }else{
        term2 = Xcons.binaryOp(Xcode.MUL_EXPR, coef, term);
      }
      
      if(xRet == null){
        xRet = term2;
      }else{
//        xRet = Xcons.List(Xcode.PLUS_EXPR, BasicType.intType, xRet, term2);
        xRet = Xcons.binaryOp(Xcode.PLUS_EXPR, xRet, term2);
      }
    }
    if(xRet == null){
      xRet = Xcons.IntConstant(0);
    }
    return xRet;
  }
  /**
   *
   **/
  public static void correctIntTerm(Xobject xExpr, Vector varTerms, Vector varCoef){
    varTerms.removeAllElements();
    varCoef.removeAllElements();
    
    varTerms.add(Xcons.IntConstant(0));
    varCoef.add(Xcons.IntConstant(1));
    
    _correctIntTerm(xExpr, 1, varTerms, varCoef);
    
    //check const term
    if(((Xobject)varTerms.get(0)).getInt() == 0){
      varTerms.remove(0);
      varCoef.remove(0);
    }
  }
  /**
   *
   **/
  private static void _correctIntTerm(Xobject xExpr, int sign, 
                                      Vector varTerms, Vector varCoef){
    if(xExpr == null) return ;
    
    
    XobjList xlExpr = null;
    if(xExpr instanceof XobjList)
      xlExpr = (XobjList)xExpr;
    
    
    //
    switch(xExpr.Opcode()){
    case Xcode.PLUS_EXPR:
      _correctIntTerm(xlExpr.getArg(0), sign, varTerms, varCoef);
      _correctIntTerm(xlExpr.getArg(1), sign, varTerms, varCoef);
      return ;
    case Xcode.MINUS_EXPR:
      _correctIntTerm(xlExpr.getArg(0), sign, varTerms, varCoef);
      _correctIntTerm(xlExpr.getArg(1),-sign, varTerms, varCoef);
      return ;
    case Xcode.UNARY_MINUS_EXPR:
      _correctIntTerm(xlExpr.getArg(0),-sign, varTerms, varCoef);
      return ;
    case Xcode.MUL_EXPR:
      Xobject xArg0 = xlExpr.getArg(0);
      Xobject xArg1 = xlExpr.getArg(1);
      
      if(xArg0.Opcode() == Xcode.INT_CONSTANT){
        _correctIntTerm(xArg1, sign * xArg0.getInt(), varTerms, varCoef);
        return;
      }
      if(xArg1.Opcode() == Xcode.INT_CONSTANT){
        _correctIntTerm(xArg0, sign * xArg1.getInt(), varTerms, varCoef);
        return;
      }
    default:
    }
    
    if(xExpr.Opcode() == Xcode.INT_CONSTANT){
      //萔ƂBvarTermŝOԖڂɒlB
      Xobject x = (Xobject)varTerms.get(0);
      int c = x.getInt() + sign * xExpr.getInt();
      varTerms.set(0,Xcons.IntConstant(c));
    }else{
      //ϐƂB
      boolean flag = false;
      for(int i = 1 ; i < varTerms.size() ; i++){
        Xobject x = (Xobject)varTerms.get(i);
        if(compareXobj(x, xExpr)){
          Xobject coefOld = (Xobject)varCoef.get(i);
          Xobject coefNew = Xcons.IntConstant(coefOld.getInt() + sign);
          varCoef.set(i, coefNew);
          flag = true;
        }
        
      }
      if(!flag){
        varTerms.add(xExpr);
        varCoef.add(Xcons.IntConstant(sign));
      }
      
    }
    
    return ;
  }
  
  public static void printXObj(Xobject xobj){
    XobjectPrintWriter writer = new XobjectPrintWriter(System.out);
    
    writer.printObject(xobj);
  }

}

