package scmopt;

import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class loopStripMine {
  protected Optimizer optimize;
  protected ForBlock fb;

  public loopStripMine(Optimizer opt, ForBlock fblock) {
    this.optimize = opt;
    this.fb = fblock;
  }
  public ForBlock getOptLoop(Xobject step) {
    BasicBlock init, cond, iter, bb;
    Xobject tmp;
     
    Xobject outer = getOutLoopVar(fb.getLoopVar());

//    System.out.println(fb.getInitBBlock().getTail());

    // generate Init BasicBlock for mining loop
    init = genInitBB(outer, fb.getLowerBound());
    init.insert(fb.getInitBBlock().toXobject());//₵}u
    
    // generate Cond BasicBlock for mining loop
    tmp  = fb.getCondBBlock().getExpr();
    cond = genCondBB(tmp.Opcode(), outer, tmp.right());
    
    // generate Iter BasicBlock for mining loop
    tmp  = fb.getIterBBlock().getHead().getExpr();
    iter = genIterBB(tmp.Opcode(), outer, step);
    
    BlockList bl = new BlockList(fb);

    Xobject t0 = optimize.newTempVar(BasicType.intType).Ref();
    Xobject lv = Xcons.binaryOp(Xcode.PLUS_EXPR, outer, step);
    Xobject rv = fb.getUpperBound();
    bl.insert(genMinOp(t0, lv, rv));

    // modify init and cond part of original loop
    fb.setInitBlock(genInitBB(fb.getLoopVar(), outer)); //}u
//    fb.getInitBBlock().getTail().getExpr().setRight(outer);
    fb.getCondBBlock().getExpr().setRight(t0);

    ForBlock out = (ForBlock) Bcons.FOR(init, cond, iter, bl);

    return out;
  }

  
  protected Xobject getOutLoopVar(Xobject x){ 
    String var = new String("_out_" + x.getName());
    Xobject obj = Xcons.Symbol(x.Opcode(), x.Type(), var);
    optimize.addIdList(var, BasicType.intType);
    return obj;
  }

  protected BasicBlock genInitBB(Xobject var, Xobject lower){
    return BasicBlock.Statement(Xcons.Set(var, lower));
  }

  protected BasicBlock genCondBB(int code, Xobject var, Xobject val){
    Xobject cond = Xcons.binaryOp(code, var, val);
    return BasicBlock.Cond(cond);
  }

  protected BasicBlock genIterBB(int code, Xobject var, Xobject val){
    Xobject iter = Xcons.asgOp(code, var, val);
    return BasicBlock.Statement(iter);
  }

  protected Xobject genMinOp(Xobject v, Xobject lv, Xobject rv){
    Xobject v1  = Xcons.binaryOp(Xcode.LOG_LT_EXPR, lv, rv);
    Xobject v2  = Xcons.List(lv, rv);
    Xobject tmp = Xcons.List(Xcode.CONDITIONAL_EXPR, BasicType.intType, v1, v2);
    return Xcons.Set(v, tmp);
  }

}
