// $RWC_Release$
// $RWC_Copyright$
package st;

import exc.object.*;
import exc.block.*;
import exc.flow.*;
import java.util.*;

public class ControlFlowGraphSt
{
  ControlFlowGraph cfg;

  public ControlFlowGraphSt(BlockList body){
    BlockIterator i = new topdownBlockIterator(body);
    for(i.init(); !i.end(); i.next()){
      Block b = i.getBlock();
      if(b.Opcode() == Xcode.FOR_STATEMENT) {
	if(b.getPrev() == null || b.getPrev().Opcode() != Xcode.LIST)
	  b.insert(Bcons.emptyBlock());
	if(b.getNext() == null || b.getNext().Opcode() == Xcode.LIST)
	  b.add(Bcons.emptyBlock());
      } else if (b.Opcode() == Xcode.IF_STATEMENT) {
        if (b.getElseBody() == null) {
          b.setElseBody(new BlockList(Bcons.emptyBlock()));
        } else if (b.getElseBody().isEmpty()) {
          b.getElseBody().add(Bcons.emptyBlock());
        }
      }
    }
    cfg = new ControlFlowGraph(body);
  }
  public ControlFlowGraph get() { return cfg;}
}
