static char rcsid[] = "$Id: omniIntr.c,v 1.1.1.1 2004-02-06 18:14:52 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
#include <stdio.h>
#include "f2c.h"

#ifdef NO_IEEEFP_H
# define isnand(x) isnan(x)
# define isnanf(x) isnan(((double)(x)))
#endif /* NO_IEEEFP_H */

#ifdef OMNI_OS_CYGWIN32
# define isnand(x) isnan(x)
# ifdef isnanf
#  undef isnanf
# endif /* isnanf */
#endif /* OMNI_OS_CYGWIN32 */

void
_to_str(dst, src, len)
     char *dst;
     char *src;
     int len;
{
    memcpy(dst, src, len);
    dst[len] = '\0';
}

void
_str_copy(dst, src, dstLen, srcLen)
     char *dst;
     char *src;
     int dstLen;
     int srcLen;
{
    int minLen = (dstLen > srcLen) ? srcLen : dstLen;
    (void)memcpy(dst, src, minLen);
    if (dstLen > minLen) {
	memset(dst + minLen, DEFAULT_UNINITED_CHAR, dstLen - minLen);
    }
}

/* NOTE: dst_len is the length of dst string!! */
void
_str_subcopy(dst,dst_len,dst_base,src,src_base,src_len)
    char *dst,*src;
    int dst_base,dst_len,src_base,src_len;
{
    if (dst_len <= 0) return;
    if (src == NULL) {
	/* "Fill the rest" mode */
	int fillLen = dst_len - dst_base;
	if (fillLen <= 0) {
	    return;
	}
	(void)memset(dst + dst_base, DEFAULT_UNINITED_CHAR, fillLen);
    } else {
	/*
	 * Note:
	 * In this case, we don't have to be care about length of
	 * dst_base and dst_len. `cause:
	 *
	 * 	case 1: LHS is simple character expression. The
	 *		dst_base must be zero. If dst_base is greater
	 *		than room of the LHS variable, It must be a
	 *		programmer's misstake.
	 *
	 * 	case 2: LHS is substr. Where Foo(M:N), if M or N are
	 *		greater than Foo's room, It must be a
	 *		programmer's misstake.
	 */
	int cpLen = (dst_len > src_len) ? src_len : dst_len;
	(void)memcpy(dst + dst_base, src + src_base, cpLen);
	if (dst_len > src_len) {
	    int restLen = dst_len - src_len;
	    (void)memset(dst + dst_base + src_len, DEFAULT_UNINITED_CHAR, restLen);
	}	    
    }
}

/*
 * Complex basic runtime 
 */

#if 0
complex
C_const(re, im)
     float re;
     float im;
{
    complex c;
    c.r = re;
    c.i = im;
    return c;
}

doublecomplex
Z_const(re, im)
     double re;
     double im;
{
    doublecomplex z;
    z.r = re;
    z.i = im;
    return z;
}

complex
C_add(a, b)
     complex a;
     complex b;
{
    complex c;
    c.r = a.r + b.r;
    c.i = a.i + b.i;
    return c;
}

doublecomplex
Z_add(a, b)
     doublecomplex a;
     doublecomplex b;
{
    doublecomplex c;
    c.r = a.r + b.r;
    c.i = a.i + b.i;
    return c;
}

complex
C_sub(a, b)
     complex a;
     complex b;
{
    complex c;
    c.r = a.r - b.r;
    c.i = a.i - b.i;
    return c;
}

doublecomplex
Z_sub(a, b)
     doublecomplex a;
     doublecomplex b;
{
    doublecomplex c;
    c.r = a.r - b.r;
    c.i = a.i - b.i;
    return c;
}

complex
C_neg(a)
     complex a;
{
    complex c;
    c.r = -a.r;
    c.i = -a.i;
    return c;
}

doublecomplex
Z_neg(a)
     doublecomplex a;
{
    doublecomplex c;
    c.r = -a.r;
    c.i = -a.i;
    return c;
}

complex
C_mul(a, b)
     complex a;
     complex b;
{
    complex c;
    c.r = a.r*b.r - a.i*b.i;
    c.i = a.r*b.i + a.i*b.r;
    return c;
}

doublecomplex
Z_mul(a, b)
     doublecomplex a;
     doublecomplex b;
{
    doublecomplex c;
    c.r = a.r*b.r - a.i*b.i;
    c.i = a.r*b.i + a.i*b.r;
    return c;
}

complex
C_div(a, b)
     complex a;
     complex b;
{
    complex c;
    double d;

    d = b.r*b.r + b.i*b.i;
    c.r = (a.r*b.r+a.i*b.i)/d;
    c.i = (a.i*b.r-a.r*b.i)/d;
    return c;
}

doublecomplex
Z_div(a, b)
     doublecomplex a;
     doublecomplex b;
{
    doublecomplex c;
    double d;

    d = b.r*b.r + b.i*b.i;
    c.r = (a.r*b.r+a.i*b.i)/d;
    c.i = (a.i*b.r-a.r*b.i)/d;
    return c;
}
#endif


/*
 * complex power
 */
complex
C_pow_ci(c, i)
     complex c;
     integer i;
{
    complex ret;
    (void)pow_ci(&ret, &c, &i);
    return ret;
}

complex
C_pow_cd(c, d)
     complex c;
     doublereal d;
{
    complex ret;
    doublecomplex zRet, zA, zB;

    zA.r = (doublereal)c.r;
    zA.i = (doublereal)c.i;
    zB.r = d;
    zB.i = 0.0;
    (void)pow_zz(&zRet, &zA, &zB);
    ret.r = (real)zRet.r;
    ret.i = (real)zRet.i;

    return ret;
}

complex
C_pow_ic(i, c)
     integer i;
     complex c;
{
    complex ret;
    doublecomplex zRet, zA, zB;

    zA.r = (doublereal)i;
    zA.i = 0.0;
    zB.r = (doublereal)c.r;
    zB.i = (doublereal)c.i;
    (void)pow_zz(&zRet, &zA, &zB);
    ret.r = (real)zRet.r;
    ret.i = (real)zRet.i;

    return ret;
}

complex
C_pow_dc(d, c)
     doublereal d;
     complex c;
{
    complex ret;
    doublecomplex zRet, zA, zB;

    zA.r = d;
    zA.i = 0.0;
    zB.r = (doublereal)c.r;
    zB.i = (doublereal)c.i;
    (void)pow_zz(&zRet, &zA, &zB);
    ret.r = (real)zRet.r;
    ret.i = (real)zRet.i;

    return ret;
}


doublecomplex
Z_pow_zi(z, i)
     doublecomplex z;
     integer i;
{
    doublecomplex ret;
    (void)pow_zi(&ret, &z, &i);
    return ret;
}

doublecomplex
Z_pow_zd(z, d)
     doublecomplex z;
     doublereal d;
{
    doublecomplex zRet, zB;

    zB.r = d;
    zB.i = 0.0;
    (void)pow_zz(&zRet, &z, &zB);

    return zRet;
}

doublecomplex
Z_pow_iz(i, z)
     integer i;
     doublecomplex z;
{
    doublecomplex zRet, zA;

    zA.r = (doublereal)i;
    zA.i = 0.0;
    (void)pow_zz(&zRet, &zA, &z);

    return zRet;
}

doublecomplex
Z_pow_dz(d, z)
     doublereal d;
     doublecomplex z;
{
    doublecomplex zRet, zA;

    zA.r = d;
    zA.i = 0.0;
    (void)pow_zz(&zRet, &zA, &z);

    return zRet;
}


doublecomplex
Z_pow_cz(c, z)
     complex c;
     doublecomplex z;
{
    doublecomplex zRet, zA;

    zA.r = (doublereal)c.r;
    zA.i = (doublereal)c.i;
    (void)pow_zz(&zRet, &zA, &z);
    
    return zRet;
}

doublecomplex
Z_pow_zc(z, c)
     doublecomplex z;
     complex c;
{
    doublecomplex zRet, zB;

    zB.r = (doublereal)c.r;
    zB.i = (doublereal)c.i;
    (void)pow_zz(&zRet, &z, &zB);
    
    return zRet;
}

complex
C_pow_cc(cA, cB)
     complex cA;
     complex cB;
{
    complex ret;
    doublecomplex zRet, zA, zB;

    zA.r = (doublereal)cA.r;
    zA.i = (doublereal)cA.i;
    zB.r = (doublereal)cB.r;
    zB.i = (doublereal)cB.i;
    (void)pow_zz(&zRet, &zA, &zB);
    ret.r = (real)zRet.r;
    ret.i = (real)zRet.i;

    return ret;
}

doublecomplex
Z_pow_zz(zA, zB)
     doublecomplex zA;
     doublecomplex zB;
{
    doublecomplex zRet;
    (void)pow_zz(&zRet, &zA, &zB);
    return zRet;
}


char *
i2c(retval, i)
     char *retval;
     int i;
{
    *retval = i % 256;
    return retval;
}


int
c2i(c, len)
     char *c;
     int len;
{
    return c[0];
}


void
#ifdef KR_headers
__checkNaN_real(val, fileName, lineNo, genCore)
     real val;
     char *fileName;
     int lineNo;
     int genCore;
#else
__checkNaN_real(real val, char *fileName, int lineNo, int genCore)
#endif /* KR_headers */
{
    if (isnanf((float)val) != 0) {
	fprintf(stderr, "float NaN at file '%s' line %d.\n",
		fileName, lineNo);
	if (genCore == 1) {
	    abort();
	}
    }
}


void
__checkNaN_dreal(val, fileName, lineNo, genCore)
     doublereal val;
     char *fileName;
     int lineNo;
     int genCore;
{
    if (isnand((double)val) != 0) {
	fprintf(stderr, "double NaN at file '%s' line %d.\n",
		fileName, lineNo);
	if (genCore == 1) {
	    abort();
	}
    }
}

void
__abort_ASGOTO()
{
    fprintf(stderr,"bad assigned GOTO, abort!\n");
    abort();
}
