static char rcsid[] = "$Id: ogr_main.c,v 1.2 2004-10-15 03:52:18 m-hirano Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
#include "exc_platform.h"
#include "grpc.h"
#include "omp.h"

int __ogr_enable = 1;	/* export to emitted code. */

extern int _ompc_main(int argc, char *argv[]);
extern void _ompc_init(int argc, char *argv[]);
extern void _ompc_terminate(int);

extern int	_ogr_init(int argc, char *argv[]);
extern void	_ogr_final(void);

int
main(int argc, char *argv[]) {
    int status;
    char *ogrDisableEnv = getenv("OGR_DISABLE");

    if (ogrDisableEnv != NULL) {
	if (strcasecmp(ogrDisableEnv, "1") == 0 ||
	    strcasecmp(ogrDisableEnv, "Yes") == 0 ||
	    strcasecmp(ogrDisableEnv, "True") == 0) {
	    __ogr_enable = 0;
	}
    }

    (void)signal(SIGFPE, SIG_IGN);

    _ompc_init(argc, argv);

    if (__ogr_enable == 1) {
	if (_ogr_init(argc, argv) != 1) {
	    return 1;
	}
    }

    status = _ompc_main(argc, argv);

    if (__ogr_enable == 1) {
	_ogr_final();
    }

    _ompc_terminate(status);

    return 0;
}
