/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
#if !(defined(__USE_RHINET__) && defined(__USE_TRUN__))

#include <unistd.h>
#include <stdlib.h>
#include "ompd.h"

/* runtime library communicator */
char _ompd_node_processor_name[MPI_MAX_PROCESSOR_NAME];

MPI_Comm _ompd_comm;

void _ompd_mpi_at_exit ();

void
_ompd_mpi_init (int *argc_p, char ***argv_p)
{
  int namelen;

  /* initialize message passing system */
  MPI_Init (argc_p, argv_p);
  MPI_Comm_size (MPI_COMM_WORLD, &_ompc_n_node);
  MPI_Comm_rank (MPI_COMM_WORLD, &_ompc_node_id);
  MPI_Get_processor_name (_ompd_node_processor_name, &namelen);

  fprintf (stderr,"Process %d on %s\n",
	   _ompc_node_id, _ompd_node_processor_name);

  /* setup communicator thread management */
  MPI_Comm_dup (MPI_COMM_WORLD, &_ompd_comm);

  atexit (_ompd_mpi_at_exit);

  /* initialize global variable */
  _ompc_n_proc      = _ompc_n_node;
  _ompc_max_threads = _ompc_n_node;
  _ompc_num_threads = _ompc_n_node;
}

void
_ompd_mpi_at_exit ()
{
  /* nothing */
}

#endif /* __USE_RHINET__ */

