/* 
 * $Id: ompd_server.h,v 1.1.1.1 2004-02-06 18:14:58 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */

typedef char byte1;
typedef short byte2;
typedef long int word4;
typedef long long int word8;	/* for double */

#define MSG_NONE  0
#define MSG_LOOP_NEXT	1	/* loop_next()->b,e */
#define MSG_LOCK	2	/* lock(addr) */
#define MSG_UNLOCK	3	/* unlock(addr) */
#define MSG_CRITICAL_LOCK 4	/* critical_lock(lp) */
#define MSG_CRITICAL_UNLOCK 5	/* critical_unlock(lp) */
#define MSG_ORDERED_BEGIN 6	/* ordered_begin(loop_id) */
#define MSG_ORDERED_END 7	/* ordered_end() */
#define MSG_ATOMIC_UPDATE 8	/* atomic_update(addr,size) */

#define RMEM_READ  10
#define RMEM_WRITE 11
#define RMEM_WRITE_FLUSH 12

#define RMEM_READ_BLOCK  13
#define RMEM_WRITE_BLOCK 14

#define OMPD_MAX_CMD  32

typedef struct _ompd_packet {
    char cmd;
    unsigned char id;
    unsigned int size;
    void *addr;
    union {
	byte1 c;
	byte2 s;
	word4 w;
	word8 d;
	unsigned int size; /* for block message */
	int args[2];
    } data;
} ompd_packet;

extern char _ompd_rmem_buffer[];
extern int _ompd_sock_fd;	/* descriptor */

/* message handlers */
void _ompd_MSG_NONE_handler(int fd,ompd_packet *p);
void _ompd_MSG_LOOP_NEXT_handler(int fd,ompd_packet *p);
void _ompd_MSG_LOCK_handler(int fd,ompd_packet *p);
void _ompd_MSG_UNLOCK_handler(int fd,ompd_packet *p);
void _ompd_MSG_CRITICAL_LOCK_handler(int fd,ompd_packet *p);
void _ompd_MSG_CRITICAL_UNLOCK_handler(int fd,ompd_packet *p);
void _ompd_MSG_ORDERED_BEGIN_handler(int fd,ompd_packet *p);
void _ompd_MSG_ORDERED_END_handler(int fd,ompd_packet *p);
void _ompd_MSG_ATOMIC_UPDATE_handler(int fd,ompd_packet *p);

void _rmem_READ_handler(int fd,ompd_packet *p);
void _rmem_WRITE_handler(int fd,ompd_packet *p);
void _rmem_WRITE_FLUSH_handler(int fd,ompd_packet *p);
void _rmem_READ_BLOCK_handler(int fd,ompd_packet *p);
void _rmem_WRITE_BLOCK_handler(int fd,ompd_packet *p);

void _write_n(int fd, char *p, int size);
void _read_n(int fd, char *p, int size);

