/*
 *  $Id: loop4.c,v 1.1.1.1 2004-02-06 18:15:00 msato Exp $
 */

#if 0
/**  original code  **/

void
loop(n, a, b)
    int n, *a, *b;
{
    int i;

#pragma omp for
    for (i = 0; i < n - 1; ++i) {
	b[i + 1] = a[i] + a[i + 1];
    }

#pragma omp for
    for (i = 0; i < n - 1; ++i) {
	a[i + 1] = b[i] + b[i + 1];
    }
}
#endif

/*
 *
 */

#define NO_MERGE

#include <stdio.h>
#include <stdlib.h>
#include "tdl.h"

void
loop(n, a, b, a_desc, b_desc)
    int n;
    int *a, *b;
    TDL_desc a_desc, b_desc;
{
    static int n0 = 0, n1 = 0;
    static TDL_desc a_desc0, b_desc0;
    static TDL_desc a_desc1, b_desc1;
    int i;

    {
	int start, end, step;
	int l_start, l_end, l_step;

	start = 0;
	end = n - 1;
	step = 1;

	/**  Compute area of Computation  **/

	TDL_loop_schedule(TDL_BLOCK, start, end, step,
			  &l_start, &l_end, &l_step);

	if (n0 == 0 || n != n0
	    || a_desc0 == (TDL_desc)NULL || b_desc0 == (TDL_desc)NULL) {

	    /*
	     *  Phase I: Inspector
	     */

	    /**  Create new distribution desc.  **/

	    n0 = n;

	    if (a_desc0 != NULL)
		TDL_desc_free(a_desc0);
	    if (b_desc0 != NULL)
		TDL_desc_free(b_desc0);

	    a_desc0 = TDL_desc_create_desc(a_desc);
	    b_desc0 = TDL_desc_create_desc(b_desc);

	    /**  Inspect access pattern (1)  **/

	    for (i = l_start; i < l_end; i += l_step) {
		TDL_inspect_home((void*)&a[i], sizeof(int), a_desc0);
		TDL_inspect_home((void*)&a[i + 1], sizeof(int), a_desc0);
		TDL_inspect_home((void*)&b[i + 1], sizeof(int), b_desc0);
	    }

	    /**  Decide distribution of a[] and b[]  **/

	    TDL_desc_fix_home(a_desc0);
	    TDL_desc_fix_home(b_desc0);

	    /*
	     *  If there is a small difference, merge sharing information.
	     */
#ifndef NO_MERGE
	    TDL_desc_merge(a_desc, a_desc0);
	    TDL_desc_merge(b_desc, b_desc0);
#endif
	    /**  Inspect access pattern (2)  **/

	    for (i = l_start; i < l_end; i += l_step) {
		TDL_inspect_ref((void*)&a[i], sizeof(int), a_desc0);
		TDL_inspect_ref((void*)&a[i + 1], sizeof(int), a_desc0);
		TDL_inspect_modify((void*)&b[i + 1], sizeof(int), b_desc0);
	    }

	    /**  Message aggregation & creation of recv/send list. **/

	    TDL_desc_fix_ref(a_desc0);
	    TDL_desc_fix_modify(b_desc0);
	}

	/**  Redistribute & change current distribution.  **/

	TDL_fence();
	TDL_remap_ref(a_desc, a_desc0);
	TDL_remap_home(b_desc, b_desc0);
	TDL_fence();

	/*
	 *  Phase II: Executor
	 */

	for (i = l_start; i < l_end; i += l_step) {
	    b[i + 1] = a[i] + a[i + 1];
	}

	/**  Update **/

	TDL_fence();
	TDL_update_modify(b_desc);
	TDL_fence();

for (i = start; i < end; i += step)
    if (TDL_IS_HOME(b_desc, &b[i + 1]))
	printf("[%d] b[%d] (%p) = %d\n", TDL_gThreadNum, i + 1,
	       &b[i + 1], b[i + 1]);

    }

    {
	int start, end, step;
	int l_start, l_end, l_step;

	start = 0;
	end = n - 1;
	step = 1;

	/**  Compute area of Computation  **/

	TDL_loop_schedule(TDL_BLOCK, start, end, step,
			  &l_start, &l_end, &l_step);

	if (n1 == 0 || n != n1
	    || a_desc1 == (TDL_desc)NULL || b_desc1 == (TDL_desc)NULL) {

	    /*
	     *  Phase I: Inspector
	     */

	    /**  Create new distribution desc.  **/

	    n1 = n;

	    if (a_desc1 != NULL)
		TDL_desc_free(a_desc1);
	    if (b_desc1 != NULL)
		TDL_desc_free(b_desc1);

	    a_desc1 = TDL_desc_create_desc(a_desc);
	    b_desc1 = TDL_desc_create_desc(b_desc);

	    /**  Inspect access pattern (1)  **/

	    for (i = l_start; i < l_end; i += l_step) {
		TDL_inspect_home((void*)&b[i], sizeof(int), b_desc1);
		TDL_inspect_home((void*)&b[i + 1], sizeof(int), b_desc1);
		TDL_inspect_home((void*)&a[i + 1], sizeof(int), a_desc1);
	    }

	    /**  Decide distribution of a[] and b[]  **/

	    TDL_desc_fix_home(a_desc1);
	    TDL_desc_fix_home(b_desc1);

	    /*
	     *  If there is a small difference, merge sharing information.
	     */
#ifndef NO_MERGE
	    TDL_desc_merge(a_desc, a_desc1);
	    TDL_desc_merge(b_desc, b_desc1);
#endif
	    /**  Inspect access pattern (2)  **/

	    for (i = l_start; i < l_end; i += l_step) {
		TDL_inspect_ref((void*)&b[i], sizeof(int), b_desc1);
		TDL_inspect_ref((void*)&b[i + 1], sizeof(int), b_desc1);
		TDL_inspect_modify((void*)&a[i + 1], sizeof(int), a_desc1);
	    }

	    /**  Message aggregation & creation of recv/send list. **/

	    TDL_desc_fix_ref(b_desc1);
	    TDL_desc_fix_modify(a_desc1);
	}

	/**  Redistribute & change current distribution.  **/

	TDL_fence();
	TDL_remap_home(a_desc, a_desc1);
	TDL_remap_ref(b_desc, b_desc1);
	TDL_fence();

	/*
	 *  Phase II: Executor
	 */

	for (i = l_start; i < l_end; i += l_step) {
	    a[i + 1] = b[i] + b[i + 1];
	}

	/**  Update **/

	TDL_fence();
	TDL_update_modify(a_desc);
	TDL_fence();

for (i = start; i < end; i += step)
    if (TDL_IS_HOME(a_desc, &a[i + 1]))
	printf("[%d] a[%d] (%p) = %d\n", TDL_gThreadNum, i + 1,
	       &a[i + 1], a[i + 1]);

    }
}


/*
 *  TEST
 */

#include <mpi.h>

int *a, *b;
TDL_desc a_desc, b_desc;

int
main(argc, argv)
    int argc;
    char* argv[];
{
    int n = 10;
    double time;
    int i;

    TDL_init(&argc, &argv);

    /**  Initialization  **/

    a = (int*)malloc(sizeof(int) * n);
    a_desc = TDL_desc_create(a, sizeof(int) * n, TDL_BLOCK);
    b = (int*)malloc(sizeof(int) * n);
    b_desc = TDL_desc_create(b, sizeof(int) * n, TDL_BLOCK);

    for (i = 0; i < n; ++i)
	if (TDL_IS_HOME(a_desc, &a[i]))
	    a[i] = i;

    for (i = 0; i < n; ++i)
	if (TDL_IS_HOME(b_desc, &b[i]))
	    b[i] = 0;

TDL_desc_print(a_desc);
    
    TDL_barrier();

    time = MPI_Wtime();

    for (i = 0; i < 10; ++i) {
	loop(n, a, b, a_desc, b_desc);
	printf("[%d] %g\n", TDL_gThreadNum, MPI_Wtime() - time);
    }

TDL_desc_print(a_desc);

    free(a);
    TDL_desc_free(a_desc);
    free(b);
    TDL_desc_free(b_desc);

    TDL_finalize();

    return 0;
}
