#include <stdio.h>
#include "ompd_object.h"

/* 
 * test _ompd_read_any, _ompd_write_any, _ompd_flush_any()
 */
#define MAX_NODES	100

void test_f(void);

int A[10*MAX_NODES];

_ompc_main(int argc,char *argv[])
{
    int i, nodes;

    printf("master begin...\n");
    for(i = 0; i < 10*MAX_NODES; i++) {
      A[i] = i;
    }
    nodes = omp_get_max_threads();
    if (MAX_NODES < nodes) {
      printf ("too many nodes...\n");
      exit (1);
    }
    _ompc_do_parallel (test_f,NULL,0);
    for(i = 0; i < nodes*10; i++) {
      printf("A[%d]=%d\n", i, A[i]);
    }
    printf("master end ...\n");
}

void test_f()
{
    int	i, j, node;

    node = omp_get_thread_num ();
    printf ("hello id=%d\n", node);

    for (i=0; i<10; i++) {
      j = node * 10 + i;
      _ompd_read_any (&A[j],4);
      A[j] += node*100;
      _ompd_write_any (&A[j],4);
    }
    _ompd_flush_any ();
}


