#include <stdio.h>
#include "ompd_object.h"

/* 
 * test _rmem_read_block, _rmem_write_block
 */

#define MAX_NODES	4

void test_f0(void);
void test_f1(void);
void test_f2(void);

int A[10*MAX_NODES];

_ompc_main(int argc,char *argv[])
{
    int i,j, nodes;
    printf("master begin...\n");

    nodes = omp_get_max_threads ();
    if (MAX_NODES < nodes) {
      printf ("too many nodes\n");
      exit (1);
    }

    for(i=0; i<10*MAX_NODES; i++) {
      A[i] = i;
    }
    _ompc_do_parallel(test_f1,NULL,0);

    printf("test1:\n");
    for(i=0; i<nodes; i++) {
      for(j = 0; j < 10; j++) {
	printf(" %5d",A[i*10+j]);
      }
      printf("\n");
    }

    for(i=0; i<10*MAX_NODES; i++) {
      A[i] = i;
    }
    _ompc_do_parallel(test_f2,NULL,0);

    printf("test2:\n");
    for(i=0; i<4; i++) {
      for(j = 0; j < 10; j++) {
	printf(" %5d",A[i*10+j]);
      }
      printf("\n");
    }

    printf("master end ...\n");
}

void test_f1()
{
  int node, i, j;

  node = omp_get_thread_num ();

  _rmem_read_block((char *)(A+node*10),1,40,0);
  for(i = 0; i < 10; i++) {
    j = node*10+i;
    A[j] += node*100;
  }
  _rmem_write_block((char *)(A+node*10),1,40,0);
}

void test_f2()
{
  int node, i, j, k;

  node = omp_get_thread_num ();

  /* blk_size = 2, stride = 40, count 4 */
  _rmem_read_block((char *)(A+node*2),4,8,40);
  for(i=0; i<4; i++) {
    for(j=0; j<2; j++) {
      k = node*2+i*10+j;
      A[k] += node*100;
    }
  }
  _rmem_write_block((char *)(A+node*2),4,8,40);
}




