#include <stdio.h>
#include "ompd_object.h"

/*
 * test range calculation
 */
void test_f0(void);
void test_f1(void);
void test_f2(void);

int A[10][10];

_ompc_main(int argc,char *argv[])
{
    int i,j;


    printf("master begin...\n");

    for(i=0; i<10; i++) {
      for(j=0; j<10; j++) {
	A[i][j] = i*10+j;
      }
    }

    _ompc_do_parallel(test_f0,NULL,0);

    printf("test0:\n");
    for(i=0; i<10; i++){
      for(j=0; j<10; j++) {
	printf(" %5d",A[i][j]);
      }
      printf("\n");
    }

    for(i=0; i<10; i++) {
      for(j=0; j<10; j++) {
	A[i][j] = i*10+j;
      }
    }

    _ompc_do_parallel(test_f1,NULL,0);

    printf("test1:\n");
    for(i=0; i<10; i++) {
      for(j=0; j<10; j++) {
	printf(" %5d",A[i][j]);
      }
      printf("\n");
    }

    for(i=0; i<10; i++) {
      for(j = 0; j < 10; j++) {
	A[i][j] = i*10+j;
      }
    }

    _ompc_do_parallel(test_f2,NULL,0);

    printf("test2:\n");
    for(i=0; i<10; i++) {
      for(j=0; j<10; j++) {
	printf(" %5d",A[i][j]);
      }
      printf("\n");
    }

    printf("master end ...\n");
}

void test_f0()
{
    int node, i,j;
    ompd_obj *obj;

    node = omp_get_thread_num ();
    _ompd_D_a(&obj,(char *)A,400,4,2,10,10,0,0);

    for(i = 0; i < 10; i++) {
      for(j = 0; j < 10; j++) {
	A[i][j] = node*100+i*10+j;
      }
    }

    if(node == 1){
#if 0	/* [2..4][0..10] */
      _ompd_set_range(0,0,10,1,1);
      _ompd_set_range(1,2,4,1,1);
#endif
#if 1   /* [2..10,4,2][2..8] */
      _ompd_set_range(0,2,8,1,1);
      _ompd_set_range(1,2,10,4,2);
#endif
#if 0	/* [2..8][2..10,2:4] */
      _ompd_set_range(0,2,10,4,2);
      _ompd_set_range(1,2, 8,1,1);
#endif
      _ompd_write_array_no_cache(obj);
    }
    fflush(stdout);
}


void test_f1()
{
  int node, i,j;
  ompd_obj *obj;
  int s,e;

  node = omp_get_thread_num ();

  s = node*2;
  e = s + 2;
  _ompd_D_a(&obj,(char *)A,400,4,2,10,10,0,0);

  _ompd_set_range(0,s,e,1,1);
  _ompd_set_range(1,0,10,1,1);
  _ompd_read_array_no_cache(obj);
  for(i = 0; i < 10; i++) {
    for(j = s; j < e; j++) {
      A[i][j] += node*100;
    }
  }
  _ompd_write_array_no_cache(obj);
}


void test_f2()
{
  int node,i,j,k;
  ompd_obj *obj;
  int s,e;

  node = omp_get_thread_num ();

  s = node*2;
  e = s + 2;
  _ompd_D_a(&obj,(char *)A,400,4,2,10,10,0,0);
  _ompd_acc_for(0,s,e,1,1);
  _ompd_acc_for(1,0,10,1,1);
  _ompd_acc_range(2);
  _ompd_R_a(0,(ompd_array *)obj);
  for(i = 0; i < 10; i++) {
    for(j = s; j < e; j++) {
      A[i][j] += node*100;
    }
  }
  _ompd_acc_for(0,s,e,1,1);
  _ompd_acc_for(1,0,10,1,1);
  _ompd_acc_range(2);
  _ompd_W_a(0,(ompd_array *)obj);
  _ompd_flush(obj);
}

