#
# for PM
#
CC              =       cc -O3
AR              =       ar cr
RANLIB          =       ranlib

CFLAGS = -I/opt/score/include -g
LIBS = -L/opt/score/lib/i386-redhat7-linux2_4/ \
        -lscoreusr -lpm -lscdev -lscorecommon -lscwrap

CPPFLAGS = $(INCDIR) -DUSE_PM -DSCASH_IDLE_DETECT \
	 -DSCASH_POLLING -DSCASH_SMP -DENABLE_CHECKPOINT

#	 -DSCASH_STATS_ -DSCASH_FAULT_TRACE__ 
# -DSCASH_RHINET_ -DSCASH_HOME_REPLACE_

SRCS =	scash.c	scash_msg_handler.c \
        scash_page.c scash_dirty_page.c	scash_message.c scash_diff.c \
	scash_handler.c	scash_alloc.c	scash_barrier.c	scash_etc.c  \
	scash_flush.c	scash_lock.c	scash_update.c	

OBJS =	scash.o	scash_msg_handler.o \
        scash_page.o scash_dirty_page.o	scash_message.o scash_diff.o \
	scash_handler.o	scash_alloc.o	scash_barrier.o	scash_etc.o  \
	scash_flush.o	scash_lock.o	scash_update.o \
	scash_tlog.o tlog.o tlog-time.o \
        scash_score.o

#	scash_omsc_mpi.o \

libomscash.a: $(OBJS)
	rm -f $@
	$(AR) $@ $(OBJS)
	$(RANLIB) $@

#scash_omsc_mpi.o: scash_omsc_mpi.c
#	$(CC) $(CPPFLAGS) $(MPI_INC) -c scash_omsc_mpi.c

lap: lap.c libomscash.a
	cc $(CPPFLAGS) -o lap lap.c libomscash.a -lm $(LIBS)

lap-pm: lap-pm.c libomscash.a
	cc $(CPPFLAGS) -o lap lap-pm.c libomscash.a -lm $(LIBS)

stest: test.c libomscash.a
	cc $(CPPFLAGS) -o stest test.c libomscash.a -lm $(LIBS)

clean:
	rm -f *.o libomscash.a core.*
