/* 
 * $PCCC_Release: 
 * $PCCC_Copyright:
 */
/*
 * $Id: lock_macro.h,v 1.2 2004-10-12 05:25:42 msato Exp $
 */

#ifndef _PM_LOCK_H
#define _PM_LOCK_H

#ifdef i386
#ifndef CONFIG_SMP
#include <linux/config.h>
#ifndef CONFIG_SMP
#define CONFIG_SMP
#endif
#endif
#ifndef __SMP__
#define	__SMP__
#endif
#include <asm/bitops.h>
#include <asm/atomic.h>
#ifndef LOCK
#define LOCK "lock ; "
#endif
#include <asm/spinlock.h>
#define mb()
#else /* i386 */
#ifdef __alpha__
#ifndef CONFIG_SMP
#define _LINUX_CONFIG_H
#define CONFIG_SMP
#endif
#ifndef __SMP__
#define	__SMP__
#endif
#include <asm/bitops.h>
#include <asm/system.h>

#ifndef smp_mb__before_clear_bit
#define smp_mb__before_clear_bit()
#endif

#ifndef smp_mb__after_clear_bit
#define smp_mb__after_clear_bit()
#endif

typedef struct {
	volatile unsigned int lock /*__attribute__((aligned(32))) */;
} spinlock_t;

typedef struct { unsigned long a[100]; } __dummy_lock_t;
#define __dummy_lock(lock) (*(__dummy_lock_t *)(lock))

#define SPIN_LOCK_UNLOCKED	(spinlock_t) { 0 }
#define spin_lock_init(x)	((x)->lock = 0)

static inline void spin_unlock(spinlock_t * lock)
{
	mb();
	lock->lock = 0;
}

static inline void spin_lock(spinlock_t * lock)
{
	long tmp;

	/* Use sub-sections to put the actual loop at the end
	   of this object file's text section so as to perfect
	   branch prediction.  */
	__asm__ __volatile__(
	"1:	ldl_l	%0,%1\n"
	"	blbs	%0,2f\n"
	"	or	%0,1,%0\n"
	"	stl_c	%0,%1\n"
	"	beq	%0,2f\n"
	"	mb\n"
	".section .text2,\"ax\"\n"
	"2:	ldl	%0,%1\n"
	"	blbs	%0,2b\n"
	"	br	1b\n"
	".previous"
	: "=r" (tmp), "=m" (__dummy_lock(lock))
	: "m"(__dummy_lock(lock)));
}

#define spin_trylock(lock) (!test_and_set_bit(0,(lock)))
#else
typedef int	spinlock_t;
#endif /* __alpha__ */
#endif /* i386 */

#endif /* _PM_LOCK_H */




