/* 
 * $PCCC_Release$
 * $PCCC_Copyright$
 */
static char rcsid[] = "$Id: omsc_etc.c,v 1.2 2006-09-10 16:29:44 ojima Exp $";

#include  <stdio.h>
#include  <fcntl.h>
#include  <unistd.h>
#include  <stdlib.h>
#include  <stdarg.h>
#include  <string.h>
#include  <errno.h>
#include  <signal.h>
#include  <sys/types.h>
#include  <sys/mman.h>
#include  <errno.h>
#ifdef __linux__
#include  <sys/time.h>
#include  <unistd.h>
#endif
#include  <sched.h>

#define  __SMP__
#define  CONFIG_SMP
#define _LINUX_CONFIG_H
#define extern  static
#include  <asm/bitops.h>
#undef  extern

#include  "omsc.h"
#include  "omsc_page.h"

int scash_debug = FALSE; /* debug flag */
int scash_tlog_flag = FALSE;	/* for loging */

#ifndef smp_mb__before_clear_bit
#define smp_mb__before_clear_bit()
#endif

#ifndef smp_mb__after_clear_bit
#define smp_mb__after_clear_bit()
#endif

void
scash_inbox_init_lock(int  bp, void  *lockp)
{
    /* smp_mb__before_clear_bit();*/
    clear_bit(bp, lockp);
    /* smp_mb__after_clear_bit(); */
}

void
scash_inbox_unlock(int  bp, void  *lockp)
{
    /* smp_mb__before_clear_bit(); */
    clear_bit(bp, lockp);
    /* smp_mb__after_clear_bit(); */
}

void
scash_inbox_spin_lock(int  bp, void  *lockp)
{
  while ( test_and_set_bit(bp, lockp) )
    ;
}

int
scash_inbox_try_lock(int  bp, void  *lockp)
{
  return test_and_set_bit(bp, lockp);
}


void
scash_fatal(char *msg,...)
{
    va_list ap;
    va_start(ap,msg);
    fprintf(stderr,"SCASH FATAL[%d(%d)]:", scash.pe, getpid());
    vfprintf(stderr,msg,ap);
    fprintf(stderr,"\n");
    fflush(stderr);
    va_end(ap);
    scash_exit(1);
}

void scash_prf(char *msg,...)
{
    va_list ap;
    va_start(ap,msg);
    fprintf(stdout,"[%d(%d)] ",scash.pe, getpid());
    vfprintf(stdout,msg,ap);
    fprintf(stdout,"\n");
    fflush(stdout);
    va_end(ap);
}

/*
 * time 
 */
double  
dtime()
{
    double  ret = 0.0;
    struct  timeval  tv;

    gettimeofday(&tv, NULL);
    ret = tv.tv_usec;
    ret = (double)tv.tv_sec + (ret / (double)1000000);

    return ret;
}

double
scash_dtime()
{
    double   ret = 0.0;
    struct  timeval  tv;

    gettimeofday(&tv, NULL);

    ret = tv.tv_usec;
    ret = (double)tv.tv_sec + ret / (double)1000000;

    return ret;
}

