#include <stdio.h>
#if defined(__ia64__) || defined(__x86_64__)
#include <asm/timex.h>
#endif

#include <sys/resource.h>
#include <sys/time.h>

unsigned long long
scash_rdtsc(void)
{
    //struct rusage ru;
    unsigned long long time;
    struct timeval tv;

    //getrusage(RUSAGE_SELF, &ru);
    gettimeofday(&tv, NULL);

    time = (unsigned long long)((tv.tv_sec + tv.tv_usec*1e-06) * 1e6);
    //scash_prf("time = %lld", time);
    return time;
}


unsigned long long
scash_rdtsc2(void)
{
#ifdef i386  
        union ll {
                struct {
                        long lo;
                        long hi;
                } s;
                long long ll;
        } ll;

        __asm __volatile (
                ".byte 0xf; .byte 0x31  # RDTSC instruction\n"
                "movl %%edx, %0          # High order 32 bits\n"
                "movl %%eax, %1          # Low order 32 bits\n"
            : "=g" (ll.s.hi), "=g" (ll.s.lo) :: "eax", "edx");
        return (ll.ll);
#elif __ia64__
	return (long long)get_cycles();
#elif __x86_64__
	unsigned long long clock;
	rdtscll(clock);
	return clock;
#else
	return (long long)0;
#endif
}

#if __TEST__
main()
{
    int          i;
    long long    c0,c1;
    
    c0 =  scash_rdtsc();
    for (i = 0 ; i < 1024 ; i++)
      c1 = scash_rdtsc();

    fprintf(stderr,"rdtsc = %lld, %lld\n", c1 - c0, (c1 - c0)/1800);
}
#endif
