/* 
 * $PCCC_Release$
 * $PCCC_Copyright$
 */
static char rcsid[] = "$Id: scash_etc.c,v 1.5 2004-08-24 17:25:43 msato Exp $";

#include  <stdio.h>
#include  <fcntl.h>
#include  <unistd.h>
#include  <stdlib.h>
#include  <stdarg.h>
#include  <string.h>
#include  <errno.h>
#include  <signal.h>
#include  <sys/types.h>
#include  <sys/mman.h>
#include  <errno.h>
#ifdef __linux__
#include  <sys/time.h>
#include  <unistd.h>
#endif

#include  "scash.h"
#include  "scash_private.h"

int scash_debug = FALSE; /* debug flag */
int scash_tlog_flag = FALSE/*TRUE*/;	/* for loging */

double  
dtime()
{
    double  ret = 0.0;
    struct  timeval  tv;

    gettimeofday(&tv, NULL);
    ret = tv.tv_usec;
    ret = (double)tv.tv_sec + (ret / (double)1000000);

    return ret;
}

void
scash_fatal(char *msg, int error)
{
    scash_prf("%s: %s[%d] \n", msg, strerror(error), error);
    scash_exit(1);
}

void scash_prf(char *msg,...)
{
    va_list ap;
    va_start(ap,msg);
    fprintf(stdout,"[%d(%d)] ",scash.pe, getpid());
    vfprintf(stdout,msg,ap);
    fprintf(stdout,"\n");
    fflush(stdout);
    va_end(ap);
}

double
scash_dtime()
{
    double   ret = 0.0;
    struct  timeval  tv;

    gettimeofday(&tv, NULL);

    ret = tv.tv_usec;
    ret = (double)tv.tv_sec + ret / (double)1000000;

    return ret;
}

u_int64
scash_utime()
{
    u_int64  clockc;

    clockc = scash_rdtsc();
    clockc = clockc / 200;
    return clockc;
}

