#ifdef USE_PM
typedef long long addrHandle;

#define OMSC_INITIALIZE(argc,argv)	scash_score_initialize(argc,argv)
#define OMSC_INIT()		scash_score_init()
#define OMSC_TERMINATE(status) 	sc_terminate(status)
#define OMSC_NUM_PROC()		scash_score_num_proc()
#define OMSC_TMP_FILE(x1,x2,x3) sc_create_temporary_file2(x1,x2,x3)

#define OMSC_BARRIER() 	   	sc_barrier()
#define OMSC_RELEASE_BUF()  	scash_pm_release_buffer()

#define OMSC_WRITE(dst_node,dst_addr,src_addr,size) \
                                scash_pm_write(dst_node,dst_addr,src_addr,size)
#define OMSC_IS_WRITE_DONE()	scash_pm_is_write_done()

#define OMSC_READ(src_node,src_addr,dst_addr,size) \
                                scash_pm_read(src_node,src_addr,dst_addr,size)
#define OMSC_IS_READ_DONE()	scash_pm_is_read_done()

#define OMSC_GET_SEND_BUF(dst,bufpp,size) scash_pm_get_send_buf(dst,bufpp,size)
#define OMSC_TRUNC_BUF(size)	scash_pm_trunc_buf(size)
#define OMSC_SEND()		scash_pm_send()
#define OMSC_IS_SEND_DONE()	scash_pm_is_send_done()
#define OMSC_RECV(addr,size)	scash_pm_recv(addr,size)

#ifdef ENABLE_CHECKPOINT
extern int score_ckpt_enter_uncheckpointable();
extern int score_ckpt_leave_uncheckpointable();
extern int score_ckpt_force_checkpoint(int flag, int fd);
extern  int score_ckpt_checkpoint_file(char* fname);
#endif
#endif

#ifdef USE_MPI_TCP
typedef caddr_t addrHandle;

extern int omsc_num_proc;

#define OMSC_INITIALIZE(argc,argv)	omsc_initialize(argc,argv)
#define OMSC_INIT()		omsc_init()
#define OMSC_TERMINATE(status) 	omsc_terminate(status)
#define OMSC_NUM_PROC()		omsc_num_proc
#define OMSC_TMP_FILE(x1,x2,x3) omsc_temporary_file(x1,x2,x3)

#define OMSC_BARRIER() 	   	omsc_barrier()
#define OMSC_RELEASE_BUF()  	/* */

#define OMSC_WRITE(dst_node,dst_addr,src_addr,size) \
                                omsc_write(dst_node,dst_addr,src_addr,size)
#define OMSC_IS_WRITE_DONE()	omsc_is_write_done()

#define OMSC_READ(src_node,src_addr,dst_addr,size) \
                                omsc_read(src_node,src_addr,dst_addr,size)
#define OMSC_IS_READ_DONE()	omsc_is_read_done()

#define OMSC_GET_SEND_BUF(dst,bufpp,size) omsc_get_send_buf(dst,bufpp,size)
#define OMSC_TRUNC_BUF(size)	omsc_trunc_buf(size)
#define OMSC_SEND()		omsc_send()
#define OMSC_IS_SEND_DONE()	omsc_is_send_done()
#define OMSC_RECV(addr,size)	omsc_recv(addr,size)

#endif
