#define MAX_THREADS 256

typedef enum tlog_type {
    TLOG_UNDEF = 0,	/* undefined */
    TLOG_END = 1, 	/* END*/
    TLOG_START = 2,
    TLOG_RAW = 3, 	/* RAW information */
    TLOG_EVENT = 4,
    TLOG_EVENT_IN = 5,
    TLOG_EVENT_OUT = 6,
    TLOG_FUNC_IN = 7,
    TLOG_FUNC_OUT = 8,

    TLOG_START_EVENT = 9,

    TLOG_BARRIER_IN = 10,
    TLOG_BARRIER_OUT = 11,

    TLOG_MSGH_IN = 12,
    TLOG_MSGH_OUT = 13,

    TLOG_SEND_IN = 14,
    TLOG_SEND_OUT = 15,
    
    TLOG_PAGEF_IN = 16,
    TLOG_PAGEF_OUT = 17,

    TLOG_BSYNC_IN = 18,
    TLOG_BSYNC_OUT = 19,

    TLOG_FLUSH_ALL_IN = 20,
    TLOG_FLUSH_ALL_OUT = 21,

    TLOG_PAGE_INV_IN = 22,
    TLOG_PAGE_INV_OUT = 23,

    TLOG_PAGEF_EVENT = 24,

    TLOG_MPI_SEND_EVENT = 25,
    TLOG_MPI_RECV_EVENT = 26,

    TLOG_RMA_IN = 27,
    TLOG_RMA_OUT = 28,

    TLOG_END_END
} TLOG_TYPE;

void scash_tlog_initialize();
void scash_tlog_finalize();

void tlog_BARRIER_IN();
void tlog_BARRIER_OUT();

void tlog_START_EVENT();
void tlog_FLUSH_ALL_IN();
void tlog_FLUSH_ALL_OUT();
void tlog_PAGE_INV_IN();
void tlog_PAGE_INV_OUT();
void tlog_SEND_IN();
void tlog_SEND_OUT();
void tlog_MSGH_IN();
void tlog_MSGH_OUT();
void tlog_PAGEF_EVENT();
void tlog_PAGEF_IN();
void tlog_PAGEF_OUT();
void tlog_BARRIER_IN();
void tlog_BARRIER_OUT();
void tlog_BSYNC_IN();
void tlog_BSYNC_OUT();

void tlog_RMA_IN();
void tlog_RMA_OUT();

