/* 
 * $Id: tlog.h,v 1.5 2006-10-24 13:40:57 ojima Exp $
 * $PCCC_Release$
 * $PCCC_Copyright$
 */
#ifndef _TLOG_H
#define _TLOG_H

#define TLOG_BLOCK_SIZE 1024
typedef struct _TLOG_BLOCK {
    struct _TLOG_BLOCK *next;
    double data[TLOG_BLOCK_SIZE/sizeof(double)];
} TLOG_BLOCK;

/* every log record is 2 double words. */
typedef struct tlog_record {
    char log_type;	/* major type */
    char proc_id;	/* processor id */
    short arg1;		/* minor type */
    int arg2;
    double time_stamp;
} TLOG_DATA;

typedef struct tlog_handle {
    TLOG_BLOCK *block_top;
    TLOG_BLOCK *block_tail;
    TLOG_DATA *free_p;
    TLOG_DATA *end_p;
} TLOG_HANDLE;
 
extern TLOG_HANDLE tlog_handle_table[];

/* prototypes */
void tlog_init(char *name);
void tlog_finalize(void);
void tlog_log(int id,enum tlog_type type);
void tlog_comp_log(int id,enum tlog_type type);
void tlog_comm_log(int id,enum tlog_type type);
double tlog_timestamp(void);
double tlog_get_time(void);

void tlog_file_open();
void tlog_file_close();
void tlog_dump_data(char *datap);

void tlog_init0();
void tlog_adjust_time(double t_diff);
void tlog_reset_time(double time);

#endif /* _TLOG_H */












