static char rcsid[] = "$Id: get_nproc002.c,v 1.1.1.1 2004-02-06 18:15:33 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* omp_get_num_procs : 002
 * parallel region omp_get_num_procs ưǧ
 */

#include "omniConfig.h"
#include <stdlib.h>
#include <omp.h>
#include "omni.h"


main ()
{
  int	thds, p, i;

  int	errors = 0;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi thread.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  p = omp_get_num_procs ();

  #pragma omp parallel
  {
    if (omp_get_num_procs() != p) {
      #pragma omp critical
      errors += 1;
    }
  }

#if defined(__OMNI_SCASH__) || defined(__OMNI_SHMEM__)
  /* Omni on SCASH do not support omp_set_num_threads.
   * and, some test 
   */
  printf ("skip some tests. because, Omni on SCASH/SHMEM do not support omp_set_num_threads, yet.\n");
#else
  for (i=1; i<=thds; i++) {
    omp_set_num_threads (i);

    #pragma omp parallel
    {
      if (omp_get_num_procs() != p) {
	#pragma omp critical
	errors += 1;
      }
    }
  }
#endif

  if (errors == 0) {
    printf ("omp_get_num_procs 002 : SUCCESS\n");
    return 0;
  } else {
    printf ("omp_get_num_procs 002 : FAILED\n");
    return 1;
  }
}
