/*
 * $Id: jexc.h,v 1.1.1.1 2004-02-06 18:16:55 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */

#include "exc_platform.h"
#include "class_file.h"

#define MAX_STRING_CONSTANT 4096
#define JEXC_TEMP_FILE_NAME "jexc.out.c"

#define ROUND(x,y)	(((x)+(y)-1)/(y))*(y)
#define MAX(x,y)	((x)>(y)? (x):(y))
#define MIN(x,y)	((x)<(y)? (x):(y))

extern int debug_flag;
extern int dump_flag;
extern int nerrors;

extern class_file *class_files;
extern class_file *class_root,*class_tail;

extern int string_count;
extern int method_count;
extern int class_count;

extern char *main_class_name;

void jexc_init(void);
void input_class_file(char *file);
void jexc_translate(char *outfile);
class_file *find_class(char *name);
field_info *find_field(class_file *cfp,char *name, char *desc);
method_info *find_method(class_file *cfp,char *name, char *desc);

int data_type_size(DATA_TYPE type);
int data_type_align(DATA_TYPE type);

void output_methods(class_file *cfp,FILE *fp);

void error EXC_VARARGS(char *, fmt);
void fatal EXC_VARARGS(char *, fmt);

void init_opcode_table(void);
void init_sys_class(void);
void dump_class_file(FILE *fp, class_file *cfp);

int get_desc_narg(char *desc);

char *xmalloc(int size);
