/*
 * $Id: jexc_mem.c,v 1.1.1.1 2004-02-06 18:16:56 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */

#include "jexc.h"

/*
 * memory management 
 */
struct name_entry {
    struct name_entry *next;
    char *name;
};

/* hash table size for symbol name */
#define SYMBOL_HASH_SIZE	0x400
#define SYMBOL_HASH_MASK	(SYMBOL_HASH_SIZE - 1)
struct name_entry *name_hash_table[SYMBOL_HASH_SIZE];

char *xmalloc(int size)
{
    char *p;
    if((p = malloc(size)) == NULL){
	fprintf(stderr,"cannot alloc memory");
	exit(1);
    }
    bzero(p,size);
    return p;
}

char *intern(char *name)
{
    struct name_entry *sp;
    int     hcode;
    char   *cp;

    /* hash code, bad ?? */
    hcode = 0;
    for( cp = name ; *cp != 0 ; cp++ )
	hcode = (hcode << 1) + *cp;
    hcode &= SYMBOL_HASH_MASK;
    
    for (sp = name_hash_table[hcode] ; sp != NULL ; sp = sp->next)
	if (strcmp(name, sp->name) == 0)
	    return (sp->name);

	/* not found, allocate symbol structure */
    sp = (struct name_entry *)xmalloc(sizeof(*sp));
    sp->name = strdup(name);

    /* link it (as top of the hash list) */
    sp->next = name_hash_table[hcode];
    name_hash_table[hcode] = sp;
    return (sp->name);
}
